/* Return To The Shadowlands Source Code
 * (Based On Reconstructed Commander Keen 4-6 Source Code)
 * Copyright (C) 2021 K1n9_Duk3
 *
 * The code in this file is loosely based on
 * Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/*
CK_KEEN.C
=========

Contains the following actor types (in this order):

- Keen (regular levels)

*/

#include "CK_DEF.H"

Uint16 bounceangle [8][8] =
{
	{ 0,  0,  0,  0,  0,  0,  0,  0},
	{ 7,  6,  5,  4,  3,  2,  1,  0},
	{ 5,  4,  3,  2,  1,  0, 15, 14},
	{ 5,  4,  3,  2,  1,  0, 15, 14},
	{ 3,  2,  1,  0, 15, 14, 13, 12},
	{ 9,  8,  7,  6,  5,  4,  3,  2},
	{ 9,  8,  7,  6,  5,  4,  3,  2},
	{11, 10,  9,  8,  7,  6,  5,  4}
};

#ifndef KEEN4
arrowdirtype oppositearrow[] = {arrow_South, arrow_West, arrow_North, arrow_East, arrow_SouthWest, arrow_NorthWest, arrow_NorthEast, arrow_SouthEast};
#endif

statetype s_keenstand     = {KEENSTANDLSPR, KEENSTANDRSPR, stepthink, false, push_down, 4, 0, 32, KeenIdleThink, KeenContact, KeenStandReact, &s_keenstand};

#ifdef KEEN5
statetype s_keensurf     = {KEENSURFSPR, KEENSURFSPR, stepthink, false, push_down, 4, 0, 32, KeenStandThink, KeenContact, KeenStandReact, &s_keensurf};
#endif

statetype s_keenidlelookup = {KEENLOOKUPSPR, KEENLOOKUPSPR, stepthink, false, push_down, 60, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenstand};

statetype s_keenshrug1    = {KEENIDLE2SPR, KEENIDLE2SPR, stepthink, false, push_down, 90, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenshrug2};
statetype s_keenshrug2    = {KEENIDLE1SPR, KEENIDLE1SPR, stepthink, false, push_down, 10, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenshrug3};
statetype s_keenshrug3    = {KEENIDLE2SPR, KEENIDLE2SPR, stepthink, false, push_down, 90, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenshrug4};
statetype s_keenshrug4    = {KEENIDLE1SPR, KEENIDLE1SPR, stepthink, false, push_down, 10, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenshrug5};
statetype s_keenshrug5    = {KEENIDLE2SPR, KEENIDLE2SPR, stepthink, false, push_down, 90, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenshrug6};
statetype s_keenshrug6    = {KEENIDLE3SPR, KEENIDLE3SPR, stepthink, false, push_down, 70, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenstand};

#ifdef KEEN4
statetype s_keenmoon1     = {KEENMOON1SPR, KEENMOON1SPR, stepthink, false, push_down, 20, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenmoon2};
statetype s_keenmoon2     = {KEENMOON2SPR, KEENMOON2SPR, stepthink, false, push_down, 90, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenmoon3};
statetype s_keenmoon3     = {KEENMOON1SPR, KEENMOON1SPR, stepthink, false, push_down, 20, 0, 0, KeenIdleThink, KeenContact, KeenStandReact, &s_keenstand};
#endif

statetype s_keenread1     = {KEENREAD1SPR, KEENREAD1SPR, step, false, push_down, 16, 0, 0, 0, KeenContact, KeenStandReact, &s_keenread2};
statetype s_keenread2     = {KEENREAD2SPR, KEENREAD2SPR, step, false, push_down, 16, 0, 0, 0, KeenContact, KeenStandReact, &s_keenread3};
statetype s_keenread3     = {KEENREAD3SPR, KEENREAD3SPR, step, false, push_down, 16, 0, 0, 0, KeenContact, KeenStandReact, &s_keenread4};
statetype s_keenread4     = {KEENREAD4SPR, KEENREAD4SPR, step, false, push_down, 16, 0, 0, 0, KeenContact, KeenStandReact, &s_keenread5};
statetype s_keenread5     = {KEENREAD5SPR, KEENREAD5SPR, stepthink, false, push_down, 300, 0, 0, KeenReadThink, KeenContact, KeenStandReact, &s_keenread6};
statetype s_keenread6     = {KEENREAD6SPR, KEENREAD6SPR, stepthink, false, push_down, 16, 0, 0, KeenReadThink, KeenContact, KeenStandReact, &s_keenread7};
statetype s_keenread7     = {KEENREAD7SPR, KEENREAD7SPR, stepthink, false, push_down, 16, 0, 0, KeenReadThink, KeenContact, KeenStandReact, &s_keenread5};
statetype s_keenread8     = {KEENREAD8SPR, KEENREAD8SPR, step, false, push_down, 12, 0, 0, 0, KeenContact, KeenStandReact, &s_keenread9};
statetype s_keenread9     = {KEENREAD9SPR, KEENREAD9SPR, step, false, push_down, 12, 0, 0, 0, KeenContact, KeenStandReact, &s_keenread10};
statetype s_keenread10    = {KEENREAD2SPR, KEENREAD2SPR, step, false, push_down, 12, 0, 0, 0, KeenContact, KeenStandReact, &s_keenstand};

statetype s_keenlookup1   = {KEENLOOKUPSPR, KEENLOOKUPSPR, stepthink, false, push_down, 30, 0, 0, KeenLookUpThink, KeenContact, KeenStandReact, &s_keenlookup2};
statetype s_keenlookup2   = {KEENLOOKUPSPR, KEENLOOKUPSPR, think, false, push_down, 0, 0, 0, KeenLookUpThink, KeenContact2, KeenStandReact, NULL};

statetype s_keenduck1     = {KEENDUCK1SPR, KEENDUCK1SPR, stepthink, false, push_down, 6, 0, 0, KeenDuckThink, KeenContact, KeenStandReact, &s_keenduck2};
statetype s_keenduck2     = {KEENDUCK2SPR, KEENDUCK2SPR, stepthink, false, push_down, 24, 0, 0, KeenDuckThink, KeenContact2, KeenStandReact, &s_keenduck3};
statetype s_keenduck3     = {KEENDUCK2SPR, KEENDUCK2SPR, think, false, push_down, 0, 0, 0, KeenDuckThink, KeenContact2, KeenStandReact, NULL};
statetype s_keenafterduck = {KEENDUCK1SPR, KEENDUCK1SPR, step, false, push_down, 6, 0, 0, 0, KeenContact, KeenStandReact, &s_keenstand};

statetype s_keenUNUSED1   = {KEENDUCK1SPR, KEENDUCK1SPR, step, false, push_none, 0, 0, 0, KeenClipThink, KeenContact, KeenDrawReact, &s_keenfall1};
statetype s_keenUNUSED2   = {-1, -1, think, false, push_none, 10, 0, 0, 0, 0, DrawReact, NULL};

statetype s_keendead1     = {KEENDIE1SPR, KEENDIE1SPR, think, false, push_none, 100, 0, 0, KeenDeadThink, 0, DrawReact, &s_keendead1};
statetype s_keendead2     = {KEENDIE2SPR, KEENDIE2SPR, think, false, push_none, 100, 0, 0, KeenDeadThink, 0, DrawReact, &s_keendead2};

#ifdef KEEN4
statetype s_scubakeendead1 = {SCUBAKEENDEAD1SPR, SCUBAKEENDEAD1SPR, think, false, push_none, 100, 0, 0, KeenDeadThink, NULL, DrawReact, &s_scubakeendead1};
statetype s_scubakeendead2 = {SCUBAKEENDEAD2SPR, SCUBAKEENDEAD2SPR, think, false, push_none, 100, 0, 0, KeenDeadThink, NULL, DrawReact, &s_scubakeendead2};
#endif

statetype s_keenshoot1    = {KEENSHOOTLSPR, KEENSHOOTRSPR, step, false, push_down, 9, 0, 0, KeenShootThink, KeenContact, KeenStandReact, &s_keenshoot2};
statetype s_keenshoot2    = {KEENSHOOTLSPR, KEENSHOOTRSPR, step, false, push_down, 6, 0, 0, 0, KeenContact, KeenStandReact, &s_keenstand};

statetype s_keenshootup1  = {KEENSHOOTUSPR, KEENSHOOTUSPR, step, false, push_down, 9, 0, 0, KeenShootThink, KeenContact, KeenStandReact, &s_keenshootup2};
statetype s_keenshootup2  = {KEENSHOOTUSPR, KEENSHOOTUSPR, step, false, push_down, 6, 0, 0, 0, KeenContact, KeenStandReact, &s_keenlookup1};

statetype s_keenuseswitch = {KEENENTER1SPR, KEENENTER1SPR, step, false, push_down, 8, 0, 0, KeenUseSwitchThink, NULL, KeenStandReact, &s_keenafteruse};
statetype s_keenafteruse  = {KEENENTER1SPR, KEENENTER1SPR, step, false, push_down, 8, 0, 0, 0, 0, KeenStandReact, &s_keenstand};
statetype s_keenusekeyholder = {KEENENTER1SPR, KEENENTER1SPR, step, false, push_down, 6, 0, 0, KeenUseKeyholder, NULL, KeenStandReact, &s_keenafteruse};

statetype s_keenslide     = {KEENENTER1SPR, KEENENTER1SPR, think, false, push_none, 0, 0, 0, KeenSlideThink, 0, DrawReact, NULL};
#ifdef KEEN5
statetype s_keenusekeycard = {KEENENTER1SPR, KEENENTER1SPR, step, false, push_none, 45, 0, -64, NULL, NULL, KeenStandReact, &s_keenenterdoor1};
statetype s_keenUNUSED3    = {KEENIDLE2SPR, KEENIDLE2SPR, think, false, push_none, 0, 0, 0, NULL, NULL, DrawReact, NULL};
#endif

statetype s_keenenterdoor1 = {KEENENTER1SPR, KEENENTER1SPR, step, false, push_none, 9, 0, -64, KeenEnterDoor1, NULL, DrawReact, &s_keenenterdoor2};
statetype s_keenenterdoor2 = {KEENENTER2SPR, KEENENTER2SPR, step, false, push_none, 9, 0, -64, KeenEnterDoor2, NULL, DrawReact, &s_keenenterdoor3};
statetype s_keenenterdoor3 = {KEENENTER3SPR, KEENENTER3SPR, step, false, push_none, 9, 0, -64, KeenEnterDoor1, NULL, DrawReact, &s_keenenterdoor4};
statetype s_keenenterdoor4 = {KEENENTER4SPR, KEENENTER4SPR, step, false, push_none, 9, 0, -64, KeenEnterDoor2, NULL, DrawReact, &s_keenenterdoor5};
statetype s_keenenterdoor5 = {KEENENTER5SPR, KEENENTER5SPR, step, false, push_none, 9, 0, -64, KeenDoorThink, NULL, DrawReact, &s_keenstand};
#ifdef KEEN5
statetype s_keeninvisible = {-1, -1, step, false, push_none, 9, 0, -64, KeenDoorThink, 0, DrawReact, &s_keenstand};
#endif

statetype s_keenpole      = {KEENSHINNYL1SPR, KEENSHINNYR1SPR, think, false, push_none, 0, 0, 0, KeenPoleThink, KeenContact2, KeenDrawReact, &s_keenpole};

statetype s_keenpoleclimb1 = {KEENSHINNYL1SPR, KEENSHINNYR1SPR, slidethink, false, push_none, 8, 0, 8, KeenPoleClimbThink, KeenContact2, KeenDrawReact, &s_keenpoleclimb2};
statetype s_keenpoleclimb2 = {KEENSHINNYL2SPR, KEENSHINNYR2SPR, slidethink, false, push_none, 8, 0, 8, KeenPoleClimbThink, KeenContact2, KeenDrawReact, &s_keenpoleclimb3};
statetype s_keenpoleclimb3 = {KEENSHINNYL3SPR, KEENSHINNYR3SPR, slidethink, false, push_none, 8, 0, 8, KeenPoleClimbThink, KeenContact2, KeenDrawReact, &s_keenpoleclimb1};

statetype s_keenpoleslide1 = {KEENSLIDED1SPR, KEENSLIDED1SPR, slide, false, push_none, 8, 0, 24, KeenPoleSlideThink, KeenContact2, KeenPoleSlideReact, &s_keenpoleslide2};
statetype s_keenpoleslide2 = {KEENSLIDED2SPR, KEENSLIDED2SPR, slide, false, push_none, 8, 0, 24, KeenPoleSlideThink, KeenContact2, KeenPoleSlideReact, &s_keenpoleslide3};
statetype s_keenpoleslide3 = {KEENSLIDED3SPR, KEENSLIDED3SPR, slide, false, push_none, 8, 0, 24, KeenPoleSlideThink, KeenContact2, KeenPoleSlideReact, &s_keenpoleslide4};
statetype s_keenpoleslide4 = {KEENSLIDED4SPR, KEENSLIDED4SPR, slide, false, push_none, 8, 0, 24, KeenPoleSlideThink, KeenContact2, KeenPoleSlideReact, &s_keenpoleslide1};

statetype s_keenpoleshoot1 = {KEENPSHOOTLSPR, KEENPSHOOTRSPR, step, false, push_none, 9, 0, 0, KeenShootThink, KeenContact2, KeenDrawReact, &s_keenpoleshoot2};
statetype s_keenpoleshoot2 = {KEENPSHOOTLSPR, KEENPSHOOTRSPR, step, false, push_none, 6, 0, 0, 0, KeenContact2, KeenDrawReact, &s_keenpole};

statetype s_keenpoleshootup1 = {KEENPLSHOOTUSPR, KEENPRSHOOTUSPR, step, false, push_none, 9, 0, 0, KeenShootThink, KeenContact2, KeenDrawReact, &s_keenpoleshootup2};
statetype s_keenpoleshootup2 = {KEENPLSHOOTUSPR, KEENPRSHOOTUSPR, step, false, push_none, 6, 0, 0, 0, KeenContact2, KeenDrawReact, &s_keenpole};

statetype s_keenpoleshootdown1 = {KEENPLSHOOTDSPR, KEENPRSHOOTDSPR, step, false, push_none, 9, 0, 0, KeenShootThink, KeenContact2, KeenDrawReact, &s_keenpoleshootdown2};
statetype s_keenpoleshootdown2 = {KEENPLSHOOTDSPR, KEENPRSHOOTDSPR, step, false, push_none, 6, 0, 0, 0, KeenContact2, KeenDrawReact, &s_keenpole};

statetype s_keenwalk1     = {KEENWALKL1SPR, KEENWALKR1SPR, slidethink, true, push_down, 6, 24, 0, KeenWalkThink, KeenContact, KeenWalkReact, &s_keenwalk2};
statetype s_keenwalk2     = {KEENWALKL2SPR, KEENWALKR2SPR, slidethink, true, push_down, 6, 24, 0, KeenWalkThink, KeenContact, KeenWalkReact, &s_keenwalk3};
statetype s_keenwalk3     = {KEENWALKL3SPR, KEENWALKR3SPR, slidethink, true, push_down, 6, 24, 0, KeenWalkThink, KeenContact, KeenWalkReact, &s_keenwalk4};
statetype s_keenwalk4     = {KEENWALKL4SPR, KEENWALKR4SPR, slidethink, true, push_down, 6, 24, 0, KeenWalkThink, KeenContact, KeenWalkReact, &s_keenwalk1};

statetype s_keenpogo1     = {KEENPOGOL2SPR, KEENPOGOR2SPR, step, true, push_none, 1, 0, 0, KeenPogoThink1, KeenContact, KeenPogoReact, &s_keenpogo2};
statetype s_keenpogo2     = {KEENPOGOL2SPR, KEENPOGOR2SPR, think, true, push_none, 0, 0, 0, KeenPogoThink, KeenContact, KeenPogoReact, &s_keenpogo3};
statetype s_keenpogo3     = {KEENPOGOL1SPR, KEENPOGOR1SPR, think, true, push_none, 0, 0, 0, KeenPogoThink, KeenContact, KeenPogoReact, NULL};

statetype s_keenjump1     = {KEENJUMPL1SPR, KEENJUMPR1SPR, think, false, push_none, 0, 0, 0, KeenAirThink, KeenContact, KeenAirReact, &s_keenjump2};
statetype s_keenjump2     = {KEENJUMPL2SPR, KEENJUMPR2SPR, think, false, push_none, 0, 0, 0, KeenAirThink, KeenContact, KeenAirReact, &s_keenfall1};

statetype s_keenfall1     = {KEENJUMPL3SPR, KEENJUMPR3SPR, stepthink, false, push_none, 50, 0, 0, KeenAirThink, KeenContact, KeenAirReact, &s_keenfall2};
statetype s_keenfall2     = {KEENJUMPL2SPR, KEENJUMPR2SPR, stepthink, false, push_none, 40, 0, 0, KeenAirThink, KeenContact, KeenAirReact, &s_keenfall1};

statetype s_keenairshoot1 = {KEENJSHOOTLSPR, KEENJSHOOTRSPR, stepthink, false, push_none, 9, 0, 0, ProjectileThink4, KeenContact, KeenAirReact, &s_keenairshoot2};
statetype s_keenairshoot2 = {KEENJSHOOTLSPR, KEENJSHOOTRSPR, stepthink, true, push_none, 1, 0, 0, KeenShootThink, KeenContact, KeenAirReact, &s_keenairshoot3};
statetype s_keenairshoot3 = {KEENJSHOOTLSPR, KEENJSHOOTRSPR, stepthink, false, push_none, 6, 0, 0, ProjectileThink4, KeenContact, KeenAirReact, &s_keenfall1};

statetype s_keenairshootup1 = {KEENJSHOOTUSPR, KEENJSHOOTUSPR, stepthink, false, push_none, 9, 0, 0, ProjectileThink4, KeenContact, KeenAirReact, &s_keenairshootup2};
statetype s_keenairshootup2 = {KEENJSHOOTUSPR, KEENJSHOOTUSPR, stepthink, true, push_none, 1, 0, 0, KeenShootThink, KeenContact, KeenAirReact, &s_keenairshootup3};
statetype s_keenairshootup3 = {KEENJSHOOTUSPR, KEENJSHOOTUSPR, stepthink, false, push_none, 6, 0, 0, ProjectileThink4, KeenContact, KeenAirReact, &s_keenfall1};

statetype s_keenairshootdown1 = {KEENJSHOOTDSPR, KEENJSHOOTDSPR, stepthink, false, push_none, 9, 0, 0, ProjectileThink4, KeenContact, KeenAirReact, &s_keenairshootdown2};
statetype s_keenairshootdown2 = {KEENJSHOOTDSPR, KEENJSHOOTDSPR, stepthink, true, push_none, 1, 0, 0, KeenShootThink, KeenContact, KeenAirReact, &s_keenairshootdown3};
statetype s_keenairshootdown3 = {KEENJSHOOTDSPR, KEENJSHOOTDSPR, stepthink, false, push_none, 6, 0, 0, ProjectileThink4, KeenContact, KeenAirReact, &s_keenfall1};

statetype s_keengrabedge1 = {KEENGRABLSPR, KEENGRABRSPR, step, false, push_none, 12, 0, 0, 0, KeenContact2, KeenDrawReact, &s_keengrabedge2};
statetype s_keengrabedge2 = {KEENGRABLSPR, KEENGRABRSPR, think, false, push_none, 0, 0, 0, KeenGrabEdgeThink, KeenContact2, KeenDrawReact, NULL};

statetype s_keenclimbedge1 = {KEENCLIMBL1SPR, KEENCLIMBR1SPR, step, false, push_none, 10, 0, 0, KeenClimbEdge1Think, KeenContact2, KeenDrawReact, &s_keenclimbedge2};
statetype s_keenclimbedge2 = {KEENCLIMBL2SPR, KEENCLIMBR2SPR, step, false, push_none, 10, 0, 0, KeenClimbEdge2Think, KeenContact2, KeenDrawReact, &s_keenclimbedge3};
statetype s_keenclimbedge3 = {KEENCLIMBL3SPR, KEENCLIMBR3SPR, step, false, push_none, 10, 0, 0, KeenClimbEdge3Think, KeenContact2, KeenDrawReact, &s_keenclimbedge4};
statetype s_keenclimbedge4 = {KEENCLIMBL4SPR, KEENCLIMBR4SPR, step, false, push_none, 10, 0, 0, KeenClimbEdge4Think, KeenContact2, KeenDrawReact, &s_keenclimbedge5};
statetype s_keenclimbedge5 = {KEENSTANDLSPR, KEENSTANDRSPR, step, false, push_none, 6, 0, 0, 0, KeenContact2, KeenDrawReact, &s_keenstand};

Sint16 slopespeed[8] = {0, 0, 4, 4, 8, -4, -4, -8};
Sint16 polespeed[3] = {-8, 0, 8};

Sint16 ammotable[4] = {0, 8, 5, 5};
Sint16 bonussound[] = {
	SND_GETKEY,SND_GETKEY,SND_GETKEY,SND_GETKEY,
	SND_GETPOINTS,SND_GETPOINTS,SND_GETPOINTS,
	SND_GETPOINTS,SND_GETPOINTS,SND_GETPOINTS,
	SND_EXTRAKEEN,
	SND_GETAMMO
#ifdef KEEN5
	,SND_GETKEYCARD
#endif
};
Sint16 bonuspoints[] = {
	0, 0, 0, 0,
	100, 200, 500,
	1000, 2000, 5000,
	0,
	0
#ifdef KEEN5
	,0
#endif
};
Sint16 pickupshape[] = {
	KEYGEMPICKUPSPR, KEYGEMPICKUPSPR, KEYGEMPICKUPSPR, KEYGEMPICKUPSPR,
	BONUS100SPR, BONUS200SPR, BONUS500SPR,
	BONUS1000SPR, BONUS2000SPR, BONUS5000SPR,
	BONUS1UPSPR,
	BONUSAMMOSPR
#ifdef KEEN5
	,KEYCARDPICKUPSPR
#endif
};

Uint16 emptytile = 0;

// uninitialized variables:

Sint16 mooningstate;
Sint32 leavepoletime;
Sint16 jumptime;

//============================================================================
//============================================================================

void SpawnKeen(Sint16 x, Sint16 y, Sint16 dir)
{
	player->obclass = keenobj;
	player->active = allways;
	player->priority = 1;
	player->x = CONVERT_TILE_TO_GLOBAL(x);
	player->y = CONVERT_TILE_TO_GLOBAL(y) - 0xF1;	//TODO: weird
	player->xdir = dir;
	player->ydir = 1;
	NewState(player, &s_keenstand);
}

boolean CheckGrabPole(objtype *ob)
{
	Uint16 far *map;

	if (lasttimecount < leavepoletime)
	{
		leavepoletime = 0;
	}
	else if (lasttimecount-leavepoletime < 19)
	{
		return false;
	}
	if (c.yaxis == -1)
	{
		map = mapsegs[1] + mapbwidthtable[(ob->top+6*PIXGLOBAL)/TILEGLOBAL]/2;
	}
	else
	{
		map = mapsegs[1] + mapbwidthtable[ob->tilebottom+1]/2;
	}
	map += ob->tilemidx;
	if ((tinf[INTILE + *map] & 0x7F) == INTILE_POLE)
	{
		ob->x = CONVERT_TILE_TO_GLOBAL(ob->tilemidx-1) + 8*PIXGLOBAL;
		tmp_xmove = 0;
		tmp_ymove = c.yaxis * 32;
		ob->needtoclip = false;
		ob->state = &s_keenpole;
		return true;
	}
	return false;
}

boolean CheckInteractiveTiles(objtype *ob)
{
	Uint16 intile, intile2, temp;

	intile = tinf[INTILE + mapsegs[1][mapbwidthtable[ob->tiletop]/2+ob->tilemidx]];
	if (intile == INTILE_SWITCH0 || intile == INTILE_SWITCH1 || intile == INTILE_BRIDGESWITCH)
	{
		temp = CONVERT_TILE_TO_GLOBAL(ob->tilemidx) - 4*PIXGLOBAL;
		if (ob->x != temp)
		{
			ob->temp1 = temp;
			ob->state = &s_keenslide;
		}
		else
		{
			ob->state = &s_keenuseswitch;
		}
		upKeyHeld = true;
		return true;
	}
	else if (intile == INTILE_DOOR || intile == INTILE_KEYCARDDOOR)
	{
		temp = CONVERT_TILE_TO_GLOBAL(ob->tilemidx) + 6*PIXGLOBAL;
		intile2 = tinf[INTILE + mapsegs[1][mapbwidthtable[ob->tiletop]/2+ob->tilemidx-1]];
		if (intile2 == 2 || intile2 == 32)
			temp -= TILEGLOBAL;

		ob->ydir = motion_Down;	// RTTS addition (fix pole - door glitch)

		if (ob->x != temp)
		{
			ob->temp1 = temp;
			ob->state = &s_keenslide;
		}
#ifdef KEEN5
		else if (intile == INTILE_KEYCARDDOOR)
		{
			if (gamestate.keycard)
			{
				gamestate.keycard = false;
				SD_PlaySound(SND_OPENDOOR);
				GetNewObj(false);
				new->x = ob->tilemidx - 2;
				new->y = ob->tilebottom - 4;
				new->active = allways;
				new->obclass = decoobj;
				NewState(new, &s_dooropener);
				ob->state = &s_keenusekeycard;
				ob->priority = 0;
				upKeyHeld = true;
				return true;
			}
			else
			{
				SD_PlaySound(SND_NOWAY);
				ob->state = &s_keenstand;
				upKeyHeld = true;
				return false;
			}
		}
#endif
		else
		{
			invulnerable = 110;	//about 1.57 seconds
			ob->state = &s_keenenterdoor1;
			ob->priority = 0;
#ifdef KEEN5
			{
				Uint16 infoval = mapsegs[2][mapbwidthtable[ob->tiletop]/2 + ob->tilemidx];
				if (!infoval)
					SpawnTeleportFX();
			}
#endif
		}
		upKeyHeld = true;
		return true;
	}
	return false;
}

void KeenEnterDoor1(objtype *ob)
{
	SD_PlaySound(SND_WORLDWALK1);
	ob++;
}

void KeenEnterDoor2(objtype *ob)
{
	SD_PlaySound(SND_WORLDWALK2);
	ob++;
}

void KeenStandThink(objtype *ob)
{
#ifdef KEEN5
	if (ob->hitnorth == 25 && ob->state != &s_keensurf)
	{
		ob->state = &s_keensurf;
	}
#endif

	if (c.xaxis)
	{
		ob->state = &s_keenwalk1;
		KeenWalkThink(ob);
		tmp_xmove = (Sint16)(ob->xdir * ob->state->xmove * tics) / 4;
	}
	else if (button2down && !button2held)
	{
		button2held = true;
		if (c.yaxis == -1)
		{
			ob->state = &s_keenshootup1;
		}
		else
		{
			ob->state = &s_keenshoot1;
		}
	}
	else if (button0down && ! button0held)
	{
		button0held = true;
		SD_PlaySound(SND_JUMP);
		ob->xspeed = 0;
		ob->yspeed = -40;
		tmp_ymove = 0;
		jumptime = 18;
		ob->state = &s_keenjump1;
	}
	else if (button1down && !button1held)
	{
		button1held = true;
		SD_PlaySound(SND_JUMP);
		ob->state = &s_keenpogo1;
		ob->xspeed = 0;
		ob->yspeed = -48;
		tmp_ymove = 0;
		jumptime = 24;
	}
	else
	{
		switch (c.yaxis)
		{
		case -1:
			if (CheckGrabPole(ob))
				break;
			if (!upKeyHeld)
			{
				if (CheckInteractiveTiles(ob))
					break;
			}
			ob->state = &s_keenlookup1;
			break;
		case 1:
			if (CheckGrabPole(ob))
				break;
			ob->state = &s_keenduck1;
		}
	}
}

void KeenIdleThink(objtype *ob)
{
#ifdef KEEN5
	if (ob->hitnorth == 25 && ob->state != &s_keensurf)
	{
		ob->state = &s_keensurf;
	}
#endif

	if (c.dir != dir_None || button0down || button1down || button2down)
	{
		ob->temp1 = ob->temp2 = 0;
		ob->state = &s_keenstand;
		KeenStandThink(ob);
	}
	else
	{
		//only increase idle counter when NOT on a platform:
		if ((ob->hitnorth & ~7) != 0x18)
			ob->temp1 = ob->temp1 + tics;

		switch (ob->temp2)
		{
		case 0:
			if (ob->temp1 > 200)
			{
				ob->temp2++;
				ob->state = &s_keenidlelookup;
				ob->temp1 = 0;
			}
			break;
		case 1:
			if (ob->temp1 > 300)
			{
				ob->temp2++;
				ob->temp1 = 0;
#ifdef KEEN4
				if (mooningstate == 1)
				{
					mooningstate = 2;	//don't moon again unless the level is restarted
					ob->state = &s_keenmoon1;
				}
				else
#endif
				{
					ob->state = &s_keenshrug1;
				}
			}
			break;
		case 2:
			if (ob->temp1 > 700)
			{
				ob->temp2++;
				ob->state = &s_keenread1;
				ob->temp1 = 0;
			}
			break;
		}
	}
}

void KeenReadThink(objtype *ob)
{
	if (demo)
	{
		playstate = ex_abort;
		IN_ClearKeysDown();
	}
	if (c.dir != dir_None || button0down || button1down)
	{
		ob->temp1 = ob->temp2 = 0;
		ob->state = &s_keenread8;
	}
}

void KeenLookUpThink(objtype *ob)
{
	if (c.yaxis != -1 || c.xaxis
		|| (button0down && !button0held)
		|| (button1down && !button1held)
		|| button2down)
	{
		ob->state = &s_keenstand;
		KeenStandThink(ob);
	}
}

void KeenDuckThink(objtype *ob)
{
	Uint16 far *map;
	Sint16 y, ymove;
	Uint16 tile;

	if (button0down && ! button0held && (ob->hitnorth & 7) == 1)
	{
		button0held = true;
		y = ob->tilebottom;
		map = mapsegs[1] + mapbwidthtable[y]/2 + ob->tilemidx;
		tile = *map;
		if (tinf[WESTWALL+tile] || tinf[EASTWALL+tile] || tinf[SOUTHWALL+tile])
			return;
		tile = map[mapwidth];
		if (tinf[WESTWALL+tile] || tinf[EASTWALL+tile] || tinf[SOUTHWALL+tile])
			return;
		ymove = max(tics, 4) * 16;
		if (gamestate.platform)
			ymove += gamestate.platform->ymove;
		ob->bottom += ymove;
		gamestate.platform = NULL;
		ob->y += ymove;
		tmp_xmove = tmp_ymove = 0;
		ob->state = &s_keenfall1;
		ob->xspeed = ob->yspeed = 0;
		SD_PlaySound(SND_PLUMMET);
	}
	else if (c.yaxis != 1 || c.xaxis
		|| (button0down && !button0held)
		|| (button1down && !button1held))
	{
		ob->state = &s_keenafterduck;
	}
}

void KeenWalkThink(objtype *ob)
{
	Sint16 xmove;

	if (c.xaxis == 0)
	{
		ob->state = &s_keenstand;
		KeenStandThink(ob);
		return;
	}
	ob->xdir = c.xaxis;
	switch (c.yaxis)
	{
	case -1:
		if (CheckGrabPole(ob))
			return;
		if (!upKeyHeld)
		{
			if (CheckInteractiveTiles(ob))
				return;
		}
		break;
	case 1:
		if (CheckGrabPole(ob))
			return;
		break;
	}
	if (button2down && !button2held)
	{
		button2held = true;
		if (c.yaxis == -1)
		{
			ob->state = &s_keenshootup1;
		}
		else
		{
			ob->state = &s_keenshoot1;
		}
		return;
	}
	if (button0down && !button0held)
	{
		button0held = true;
		SD_PlaySound(SND_JUMP);
		ob->xspeed = ob->xdir * 16;
		ob->yspeed = -40;
		tmp_xmove = tmp_ymove = 0;
		jumptime = 18;
		ob->state = &s_keenjump1;
	}
	if (button1down && !button1held)
	{
		button1held = true;
		ob->state = &s_keenpogo1;
		SD_PlaySound(SND_JUMP);
		ob->xspeed = ob->xdir * 16;
		ob->yspeed = -48;
		tmp_xmove = 0;
		jumptime = 24;
		return;
	}
	xmove = slopespeed[ob->hitnorth & 7] * tics;
	tmp_xmove += xmove;
	if (ob->state == &s_keenwalk1 && ob->temp3 == 0)
	{
		SD_PlaySound(SND_WORLDWALK1);
		ob->temp3 = 1;
	}
	else if (ob->state == &s_keenwalk3 && ob->temp3 == 0)
	{
		SD_PlaySound(SND_WORLDWALK2);
		ob->temp3 = 1;
	}
	else if (ob->state == &s_keenwalk2 ||ob->state == &s_keenwalk4)
	{
		ob->temp3 = 0;
	}
}

void KeenSlideThink(objtype *ob)
{
	Sint16 xmove;

	xmove = ob->temp1 - ob->x;
	if (xmove < 0)
	{
		tmp_xmove = tmp_xmove - tics * 16;
		if (tmp_xmove > xmove)
			return;
	}
	else if (xmove > 0)
	{
		tmp_xmove = tmp_xmove + tics * 16;
		if (tmp_xmove < xmove)
			return;
	}
	tmp_xmove = xmove;
	ob->temp1 = 0;
	if (!CheckInteractiveTiles(ob))
		ob->state = &s_keenstand;
}

void KeenDoorThink(objtype *ob)
{
	Uint16 info;
	Uint16 far *map;

	map = mapsegs[2] + mapbwidthtable[ob->tilebottom]/2 + ob->tileleft;
	info = *map;
#ifdef KEEN5
	if (!info)
	{
		playstate = ex_teleported;
		ob->state = &s_keeninvisible;
		return;
	}
	else if (info == 0xB1B1)
	{
		playstate = ex_completed;
		ob->state = &s_keeninvisible;
		return;
	}
#endif
	ob->y = (CONVERT_TILE_TO_GLOBAL(info & 0xFF) - TILEGLOBAL) + 15;
	ob->x = CONVERT_TILE_TO_GLOBAL(info >> 8);
	ob->priority = 1;
	ob->needtoclip = false;
	ChangeState(ob, ob->state->nextstate);
	ob->needtoclip = true;
	CenterPlayer(ob);
}

void KeenUseSwitchThink(objtype *ob)
{
	Uint16 intile, maptile, newtile, info, sx, sy, tileoff;
	Uint16 far *map;
	Uint16 tile, x, y;
	Sint8 manim;

	tileoff = mapbwidthtable[ob->tiletop]/2 + ob->tilemidx;
	maptile = mapsegs[1][tileoff];
	newtile = maptile + (Sint8)tinf[MANIM + maptile];
	info = mapsegs[2][tileoff];
	sx = info >> 8;
	sy = info & 0xFF;
	intile = tinf[INTILE + maptile];

	RF_MemToMap(&newtile, 1, ob->tilemidx, ob->tiletop, 1, 1);
	SD_PlaySound(SND_USESWITCH);
	if (intile == INTILE_BRIDGESWITCH)
	{
		//toggle bridge:
		for (y = sy; sy+2 > y; y++)
		{
			map = mapsegs[1] + mapbwidthtable[y]/2 + sx - (y != sy);
			for (x = sx - (y != sy); x < mapwidth; x++)
			{
				tile = *(map++);
				manim = tinf[MANIM + tile];
				if (!manim)
					break;

				tile += manim;
				RF_MemToMap(&tile, 1, x, y, 1, 1);
			}
		}
	}
	else
	{
		//toggle platform blocker:
		map = mapsegs[2] + mapbwidthtable[sy]/2 + sx;
		tile = *map;
#ifdef KEEN5
		if (tile >= DIRARROWSTART && tile < DIRARROWEND)
		{
			*map = oppositearrow[tile-DIRARROWSTART]+DIRARROWSTART;
			return;
		}
#endif
		*map = tile ^ PLATFORMBLOCK;
	}
}

void KeenUseKeyholder(objtype *ob)
{
	Uint16 newtile, info, x, y, tileoff;
	Uint16 far *map;
	Uint16 tile, h;

	tileoff = mapbwidthtable[ob->tilebottom]/2 + ob->tilemidx;
	newtile = mapsegs[1][tileoff] + 18;
	info = mapsegs[2][tileoff];
	x = info >> 8;
	y = info & 0xFF;
	RF_MemToMap(&newtile, 1, ob->tilemidx, ob->tilebottom, 1, 1);
	SD_PlaySound(SND_OPENDOOR);
	GetNewObj(false);
	new->x = x;
	new->y = y;

	if (x > mapwidth || x < 2 || y > mapheight || y < 2)
		Quit("Keyholder points to a bad spot!");

	map = mapsegs[1] + mapbwidthtable[y]/2 + x;
	tile = *map;
	for (h=1, map+= mapwidth; *map == tile; h++, map+=mapwidth);
	new->temp1 = h;
	new->active = allways;
	new->needtoclip = false;
	new->obclass = decoobj;
	NewState(new, &s_gemdoor1);
}

void KeenAirThink(objtype *ob)
{
	if (jumpcheat && button0down)
	{
		ob->yspeed = -40;
		jumptime = 18;
		button0held = true;
	}
	if (jumptime)
	{
		if (jumptime <= tics)
		{
			tmp_ymove = ob->yspeed * jumptime;
			jumptime = 0;
		}
		else
		{
			tmp_ymove = ob->yspeed * tics;
			if (!jumpcheat)
				jumptime = jumptime - tics;
		}
		if (!button0down)
			jumptime = 0;

		if (jumptime == 0 && ob->state->nextstate)
			ob->state = ob->state->nextstate;
	}
	else
	{
		if (gamestate.difficulty == gd_Easy)
		{
			DoGravity3(ob);
		}
		else
		{
			DoGravity4(ob);
		}
		if (ob->yspeed > 0 && ob->state != &s_keenfall1 && ob->state != &s_keenfall2)
		{
			ob->state = ob->state->nextstate;
		}
	}
	if (c.xaxis)
	{
		ob->xdir = c.xaxis;
		AccelerateX(ob, c.xaxis*2, 24);
	}
	else
	{
		FrictionX(ob);
	}
	if (ob->hitsouth == 17)
	{
		ob->xspeed = tmp_xmove = 0;
	}
	if (button2down && !button2held)
	{
		button2held = true;
		switch (c.yaxis)
		{
		case -1:
			ob->state = &s_keenairshootup1;
			return;
		case 0:
			ob->state = &s_keenairshoot1;
			return;
		case 1:
			ob->state = &s_keenairshootdown1;
			return;
		}
	}
	if (button1down && !button1held)
	{
		button1held = true;
		ob->state = &s_keenpogo2;
		jumptime = 0;
		return;
	}
	if (c.yaxis == -1)
		CheckGrabPole(ob);
}

void KeenPogoThink1(objtype *ob)
{
	ob->yspeed = -48;
	tmp_ymove = ob->yspeed * 6;
	jumptime = 24;
	SD_PlaySound(SND_POGOBOUNCE);
}

void KeenPogoThink(objtype *ob)
{
	if (jumptime)
	{
		if (button0down || jumptime <= 9)
		{
			DoGravity1(ob);
		}
		else
		{
			DoGravity4(ob);
		}
		if (jumptime <= tics)
		{
			jumptime = 0;
		}
		else
		{
			jumptime = jumptime - tics;
		}
		if (jumptime == 0 && ob->state->nextstate)
			ob->state = ob->state->nextstate;
	}
	else
	{
		if (gamestate.difficulty == gd_Easy)
		{
			DoGravity3(ob);
		}
		else
		{
			DoGravity4(ob);
		}
	}
	if (c.xaxis)
	{
		if (ob->xspeed == 0)
			ob->xdir = c.xaxis;
		AccelerateX(ob, c.xaxis, 24);
	}
	else
	{
		tmp_xmove = tmp_xmove + ob->xspeed * tics;
		if (ob->xspeed > 0)
		{
			ob->xdir = 1;
		}
		else if (ob->xspeed < 0)
		{
			ob->xdir = -1;
		}
	}
	if (ob->hitsouth == 17)
	{
		ob->xspeed = tmp_xmove = 0;
	}
	if (button2down && !button2held)
	{
		button2held = true;
		switch (c.yaxis)
		{
		case -1:
			ob->state = &s_keenairshootup1;
			return;
		case 0:
			ob->state = &s_keenairshoot1;
			return;
		case 1:
			ob->state = &s_keenairshootdown1;
			return;
		}
	}
	if (button1down && !button1held)
	{
		button1held = true;
		ob->state = &s_keenfall1;
	}
}

void PoleActions(objtype *ob)
{
	if (c.xaxis)
		ob->xdir = c.xaxis;

	if (button2down && !button2held)
	{
		button2held = true;
		switch (c.yaxis)
		{
		case -1:
			ob->state = &s_keenpoleshootup1;
			break;
		case 0:
			ob->state = &s_keenpoleshoot1;
			break;
		case 1:
			ob->state = &s_keenpoleshootdown1;
			break;
		}
	}
	if (button0down && !button0held)
	{
		button0held = true;
		SD_PlaySound(SND_JUMP);
		ob->xspeed = polespeed[c.xaxis+1];
		ob->yspeed = -20;
		ob->needtoclip = true;
		jumptime = 10;
		ob->state = &s_keenjump1;
		ob->ydir = 1;
		leavepoletime = lasttimecount;
	}
}

void KeenPoleThink(objtype *ob)
{
	Uint16 tile;
	Uint16 far *map;

	switch (c.yaxis)
	{
	case -1:
		ob->state = &s_keenpoleclimb1;
		ob->ydir = -1;
		return;
	case 1:
		ob->state = &s_keenpoleslide1;
		ob->ydir = 1;
		KeenPoleSlideThink(ob);
		return;
	}
	if (c.xaxis)
	{
		map = mapsegs[1] + mapbwidthtable[ob->tilebottom+1]/2 + ob->tilemidx;
		tile = *map;
		if (tinf[NORTHWALL+tile])
		{
			ob->xspeed = 0;
			ob->yspeed = 0;
			ob->needtoclip = true;
			jumptime = 0;
			ob->state = &s_keenfall1;
			ob->ydir = 1;
			SD_PlaySound(SND_PLUMMET);
			return;
		}
	}
	PoleActions(ob);
}

void KeenPoleClimbThink(objtype *ob)
{
	Uint16 far *map;

	map = mapsegs[1] + mapbwidthtable[ob->tiletop]/2 + ob->tilemidx;
	if ((tinf[INTILE+*map] & 0x7F) != INTILE_POLE)
	{
		tmp_ymove = 0;
		ob->state = &s_keenpole;
		PoleActions(ob);
		return;
	}
	switch (c.yaxis)
	{
	case 0:
		ob->state = &s_keenpole;
		ob->ydir = 0;
		break;
	case 1:
		ob->state = &s_keenpoleslide1;
		ob->ydir = 1;
		break;
	}
	PoleActions(ob);
}

void KeenPoleSlideThink(objtype *ob)
{
	Uint16 far *map;
	Uint16 y;

	y = CONVERT_GLOBAL_TO_TILE(ob->bottom - 4*PIXGLOBAL);
	map = mapsegs[1] + mapbwidthtable[y]/2 + ob->tilemidx;

	if ((tinf[INTILE+*map] & 0x7F) != INTILE_POLE)
	{
		SD_PlaySound(SND_PLUMMET);
		ob->state = &s_keenfall1;
		jumptime = 0;
		ob->xspeed = polespeed[c.xaxis+1];
		ob->yspeed = 0;
		ob->needtoclip = true;
		ob->tilebottom--;
		return;
	}
	switch (c.yaxis)
	{
	case -1:
		ob->state = &s_keenpoleclimb1;
		ob->ydir = -1;
		break;
	case 0:
		ob->state = &s_keenpole;
		ob->xdir = 0;
		break;
	}
	PoleActions(ob);
}

void KeenClipThink(objtype *ob)
{
	ob->needtoclip = true;
}

void KeenGrabEdgeThink(objtype *ob)
{
	Uint16 tile;

	if (c.yaxis == -1 || ob->xdir == c.xaxis)
	{
		ob->state = &s_keenclimbedge1;
		if (ob->xdir == 1)
		{
			tile = mapsegs[1][mapbwidthtable[ob->tiletop-1]/2+ob->tileright];
		}
		else
		{
			tile = mapsegs[1][mapbwidthtable[ob->tiletop-1]/2+ob->tileleft];
		}
		if (ob->xdir == 1)
		{
			tmp_ymove = -16*PIXGLOBAL;
		}
		else
		{
			tmp_ymove = -8*PIXGLOBAL;
		}
		if (!(tinf[INTILE+tile] & INTILE_FOREGROUND))
			ob->priority = 3;
	}
	else if (c.yaxis == 1 || c.xaxis && ob->xdir != c.xaxis)
	{
		ob->state = &s_keenfall1;
		ob->needtoclip = true;
	}
}

void KeenShootThink(objtype *ob)
{
	if (ob->state == &s_keenshoot1)
	{
		if (ob->xdir == 1)
		{
			SpawnShot(ob->x + 16*PIXGLOBAL, ob->y + 4*PIXGLOBAL, dir_East);
		}
		else
		{
			SpawnShot(ob->x - 8*PIXGLOBAL, ob->y + 4*PIXGLOBAL, dir_West);
		}
	}
	if (ob->state == &s_keenairshoot2)
	{
		if (ob->xdir == 1)
		{
			SpawnShot(ob->x + 16*PIXGLOBAL, ob->y + 2*PIXGLOBAL, dir_East);
		}
		else
		{
			SpawnShot(ob->x, ob->y + 2*PIXGLOBAL, dir_West);
		}
	}
	if (ob->state == &s_keenairshootdown2)
	{
		SpawnShot(ob->x + 8*PIXGLOBAL, ob->y + 18*PIXGLOBAL, dir_South);
	}
	if (ob->state == &s_keenairshootup2)
	{
		SpawnShot(ob->x + 5*PIXGLOBAL, ob->y - 10*PIXGLOBAL, dir_North);
	}
	if (ob->state == &s_keenshootup1)
	{
		SpawnShot(ob->x + 5*PIXGLOBAL, ob->y - 10*PIXGLOBAL, dir_North);
	}
	if (ob->state == &s_keenpoleshoot1)
	{
		if (ob->xdir == 1)
		{
			SpawnShot(ob->x + 16*PIXGLOBAL, ob->y + 4*PIXGLOBAL, dir_East);
		}
		else
		{
			SpawnShot(ob->x - 8*PIXGLOBAL, ob->y + 4*PIXGLOBAL, dir_West);
		}
	}
	if (ob->state == &s_keenpoleshootup1)
	{
		if (ob->xdir == 1)
		{
			SpawnShot(ob->x + 6*PIXGLOBAL, ob->y + 4*PIXGLOBAL, dir_North);
		}
		else
		{
			SpawnShot(ob->x + 12*PIXGLOBAL, ob->y + 4*PIXGLOBAL, dir_North);
		}
	}
	if (ob->state == &s_keenpoleshootdown1)
	{
		if (ob->xdir == 1)
		{
			SpawnShot(ob->x + 6*PIXGLOBAL, ob->y + 24*PIXGLOBAL, dir_South);
		}
		else
		{
			SpawnShot(ob->x + 12*PIXGLOBAL, ob->y + 24*PIXGLOBAL, dir_South);
		}
	}
}

void KeenClimbEdge1Think(objtype *ob)
{
	if (ob->xdir == 1)
	{
		tmp_xmove = 8*PIXGLOBAL;
	}
	else
	{
		tmp_ymove = -8*PIXGLOBAL;
	}
}

void KeenClimbEdge2Think(objtype *ob)
{
	if (ob->xdir == 1)
	{
		tmp_xmove = 8*PIXGLOBAL;
		tmp_ymove = -8*PIXGLOBAL;
	}
	else
	{
		tmp_xmove = -8*PIXGLOBAL;
		tmp_ymove = -8*PIXGLOBAL;
	}
}

#pragma argsused
void KeenClimbEdge3Think(objtype *ob)
{
	tmp_ymove = -8*PIXGLOBAL;
}

void KeenClimbEdge4Think(objtype *ob)
{
	ob->needtoclip = true;
	ob->priority = 1;
	tmp_ymove = 8*PIXGLOBAL;
}

void KeenDeadThink(objtype *ob)
{
	DoGravity3(ob);
	tmp_xmove = ob->xspeed * tics;
	if (!ObjectVisible(ob))
		playstate = ex_died;
}

void KillKeen(void)
{
	if (invulnerable || godmode || player->state == &s_keenUNUSED2)
		return;

	mooningstate = 0;
	invulnerable = 30;	//0.43 seconds
	noscrolling = true;
	player->needtoclip = false;
	player->priority = 3;
#ifdef KEEN4
	if (mapon == 17)
	{
		if (US_RndT() < 0x80)
		{
			ChangeState(player, &s_scubakeendead1);
		}
		else
		{
			ChangeState(player, &s_scubakeendead2);
		}
	}
	else
#endif
	{
		if (US_RndT() < 0x80)
		{
			ChangeState(player, &s_keendead1);
		}
		else
		{
			ChangeState(player, &s_keendead2);
		}
	}
	SD_PlaySound(SND_KEENDEAD);
	player->yspeed = -40;
	player->xspeed = 16;
}

void KeenContact(objtype *ob, objtype *hit)
{
	switch (hit->obclass)
	{
	case bonusobj:
		switch (hit->temp1)
		{
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
#ifdef KEEN5
		case 12:
#endif
			SD_PlaySound(bonussound[hit->temp1]);
			hit->obclass = decoobj;
			hit->priority = 3;
			hit->shapenum = pickupshape[hit->temp1];
			GivePoints(bonuspoints[hit->temp1]);
			if (hit->temp1 < 4)
			{
				gamestate.keys[hit->temp1]++;
			}
			else if (hit->temp1 == 10)
			{
				gamestate.lives++;
			}
			else if (hit->temp1 == 11)
			{
				gamestate.ammo += ammotable[gamestate.difficulty];
			}
#ifdef KEEN5
			else if (hit->temp1 == 12)
			{
				gamestate.keycard = true;
			}
#endif
			ChangeState(hit, &s_bonusrise);
		}
		break;

#if defined KEEN4
	case oracleobj:
		if (!ob->hitnorth)
			break;

		// RTTS mod: don't show janitor dialog here
		
		SD_PlaySound(SND_LINDSEY);
		playstate = ex_rescued;
		break;
	case stunnedobj:
		if (hit->temp4 != bounderobj)
			break;
		//no break here -- drop through to platformobj is intended!
	case platformobj:
		if (!gamestate.platform)
			ClipToSpriteTop(ob, hit);
		break;
	case bounderobj:
		ClipToSprite(ob, hit, false);
		break;
	case lindseyobj:
		LindseyDialog();
#if 0
		RemoveObj(hit);
		RF_ForceRefresh();
#else
		// RTTS modification:
		playstate = ex_completed;
#endif
		break;
	case footobj:
		playstate = ex_onfoot;
		break;
#elif defined KEEN5
	case platformobj:
		if (!gamestate.platform)
			ClipToSpriteTop(ob, hit);
		break;
#elif defined KEEN6
	case shotobj:
		if (hit->temp4)
		{
			ExplodeShot(hit);
			ChangeState(ob, &s_keenstunned);
		}
		// BUG: there is no break here - this causes the impossible bullet bug
	case platformobj:
		if (!gamestate.platform)
			ClipToSpriteTop(ob, hit);
		break;
#endif
	}
}

void KeenContact2(objtype *ob, objtype *hit)
{
	switch (hit->obclass)
	{
#if defined KEEN4
	case platformobj:
		ob->needtoclip = true;
		ChangeState(ob, &s_keenfall1);
		jumptime = ob->xspeed = ob->yspeed = 0;
		ClipToSpriteTop(ob, hit);
		break;
	case madmushroomobj:
	case arachnutobj:
	case berkeloidobj:
		KillKeen();
		break;
	case bounderobj:
		ob->priority = 1;
		ob->needtoclip = true;
		ChangeState(ob, &s_keenfall1);
		jumptime = ob->xspeed = ob->yspeed = 0;
		ClipToSprite(ob, hit, false);
		break;
#elif defined KEEN5
	case platformobj:
		ob->needtoclip = true;
		ChangeState(ob, &s_keenfall1);
		jumptime = ob->xspeed = ob->yspeed = 0;
		ClipToSpriteTop(ob, hit);
		break;
	case amptonobj:
	case korathobj:
		ob->priority = 1;
		ob->needtoclip = true;
		ChangeState(ob, &s_keenfall1);
		jumptime = ob->xspeed = ob->yspeed = 0;
		break;
#elif defined KEEN6
	case platformobj:
	case gikobj:
	case flectobj:
	case bloogletobj:
		ob->priority = 1;
		ob->needtoclip = true;
		ChangeState(ob, &s_keenfall1);
		jumptime = ob->xspeed = ob->yspeed = 0;
		ClipToSpriteTop(ob, hit);
		break;
#endif
	}
}

void FollowPlatform(objtype *ob)
{
	objtype *plat;

	plat = gamestate.platform;
	if (ob->right < plat->left || ob->left > plat->right)
	{
		gamestate.platform = NULL;
	}
	else if (ob->ymove < 0)
	{
		gamestate.platform = NULL;
		if (plat->ymove < 0)
		{
			tmp_xmove = 0;
			tmp_ymove = plat->ymove;
			PushClipToWalls(ob);
		}
	}
	else
	{
		tmp_xmove = plat->xmove;
		tmp_ymove = plat->top - ob->bottom - 16;
		PushClipToWalls(ob);
		if (nopan)
		{
			ob->x &= ~0x7F;
			ob->x |= plat->x & 0x7F;
		}
		else
		{
			ob->x |= plat->x & 0x1F;
		}
		if (ob->hitsouth)
		{
			gamestate.platform = NULL;
		}
		else
		{
			ob->hitnorth = 25;
		}
	}
}

void CollectBonusTile(Uint16 x, Uint16 y, Uint16 bonus)
{
	RF_MemToMap(&emptytile, 1, x, y, 1, 1);
	SD_PlaySound(bonussound[bonus]);
	GivePoints(bonuspoints[bonus]);
	if (bonus < 4)
	{
		gamestate.keys[bonus]++;
	}
	else if (bonus == 10)
	{
		gamestate.lives++;
	}
	else if (bonus == 11)
	{
		gamestate.ammo += ammotable[gamestate.difficulty];
	}
	GetNewObj(true);
	new->obclass = decoobj;
	new->priority = 3;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = CONVERT_TILE_TO_GLOBAL(y);
	new->ydir = -1;
	new->temp2 = new->shapenum = pickupshape[bonus];
	NewState(new, &s_bonusrise);
	new->needtoclip = false;
}

void CollectLifecrumbTile(Uint16 x, Uint16 y)
{
	RF_MemToMap(&emptytile, 1, x, y, 1, 1);
	SD_PlaySound(SND_GETWATER);
	SpawnSplash(x, y);
	gamestate.lifecrumbs++;
	if (gamestate.lifecrumbs == 100)
	{
		gamestate.lifecrumbs = 0;
		SD_PlaySound(SND_EXTRAKEEN);
		gamestate.lives++;
		GetNewObj(true);
		new->obclass = decoobj;
		new->priority = 3;
		new->x = CONVERT_TILE_TO_GLOBAL(x);
		new->y = CONVERT_TILE_TO_GLOBAL(y);
		new->ydir = -1;
		new->temp2 = new->shapenum = BLUE1UPSPR;
		NewState(new, &s_bonusrise);
		new->needtoclip = false;
	}
}

void CheckTiles(objtype *ob)
{
	Uint16 x, y;
	Uint16 far *map;
	Uint16 rowdelta, intile, midx;

	if (mooningstate == 1)
		mooningstate = 0;

	map = mapsegs[1] + mapbwidthtable[ob->tiletop]/2 + ob->tileleft;
	rowdelta = mapwidth - (ob->tileright - ob->tileleft + 1);
	for (y = ob->tiletop; y <= ob->tilebottom; y++, map += rowdelta)
	{
		for (x = ob->tileleft; x <= ob->tileright; x++, map++)
		{
			intile = tinf[INTILE + *map] & INTILE_TYPEMASK;

			//useless check (0 is not handled in the switch statement anyway):
			if (!intile)
				continue;

			switch (intile)
			{
			case INTILE_DEADLY:
				KillKeen();
				break;

			case INTILE_LIFECRUMB:
				CollectLifecrumbTile(x, y);
				break;

			case INTILE_GEMSOCKET0:
			case INTILE_GEMSOCKET1:
			case INTILE_GEMSOCKET2:
			case INTILE_GEMSOCKET3:
				if (ob->tilebottom == y && ob->hitnorth
					&& ob->state != &s_keenusekeyholder
					&& gamestate.keys[intile-INTILE_GEMSOCKET0])
				{
					midx = CONVERT_TILE_TO_GLOBAL(x) + -4*PIXGLOBAL;
					if (ob->x != midx)
					{
						ob->temp1 = midx;
						ob->state = &s_keenslide;
					}
					else
					{
						gamestate.keys[intile-INTILE_GEMSOCKET0]--;
						ChangeState(ob, &s_keenusekeyholder);
						break;
					}
				}
				return;

			case INTILE_MOON:
				if (mooningstate == 0)
					mooningstate = 1;
				break;

			case INTILE_BONUS100:
			case INTILE_BONUS200:
			case INTILE_BONUS500:
			case INTILE_BONUS1000:
			case INTILE_BONUS2000:
			case INTILE_BONUS5000:
			case INTILE_EXTRALIFE:
			case INTILE_AMMO:
				CollectBonusTile(x, y, (intile-INTILE_BONUS100)+4);
				break;
			}
		}
	}
}

void KeenDrawReact(objtype *ob)
{
	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

void KeenStandReact(objtype *ob)
{
	if (!ob->hitnorth)
	{
		SD_PlaySound(SND_PLUMMET);
		ob->xspeed = ob->xdir * 8;
		ob->yspeed = 0;
		ChangeState(ob, &s_keenfall1);
		jumptime = 0;
	}
	else if ((ob->hitnorth & ~7) == 8)
	{
		KillKeen();
	}
	else if (ob->hitnorth == 41)
	{
		tmp_xmove = tics * 8;
		tmp_ymove = 0;
		ob->temp1 = 0;
		ClipToWalls(ob);
	}
	else if (ob->hitnorth == 49)
	{
		tmp_xmove = tics * -8;
		tmp_ymove = 0;
		ob->temp1 = 0;
		ClipToWalls(ob);
	}
	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

void KeenWalkReact(objtype *ob)
{
	if (!ob->hitnorth)
	{
		SD_PlaySound(SND_PLUMMET);
		ob->xspeed = ob->xdir * 8;
		ob->yspeed = 0;
		ChangeState(ob, &s_keenfall1);
		jumptime = 0;
	}
	else if ((ob->hitnorth & ~7) == 8)
	{
		KillKeen();
	}
	else if (ob->hitnorth == 41)
	{
		tmp_xmove = tics * 8;
		tmp_ymove = 0;
		ob->temp1 = 0;
		ClipToWalls(ob);
	}
	else if (ob->hitnorth == 49)
	{
		tmp_xmove = tics * -8;
		tmp_ymove = 0;
		ob->temp1 = 0;
		ClipToWalls(ob);
	}
	else if (ob->hiteast && ob->xdir == -1 || ob->hitwest && ob->xdir == 1)
	{
		ob->ticcount = 0;
		ob->state = &s_keenstand;
		ob->shapenum = ob->xdir == 1? s_keenstand.rightshapenum : s_keenstand.leftshapenum;
	}
	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

void KeenAirReact(objtype *ob)
{
	Uint16 far *map;
	Uint16 oldtop, graby, ty, tile;

	if (ob->hiteast && ob->xdir == -1 || ob->hitwest && ob->xdir == 1)
		ob->xspeed = 0;

	if (ob->hitsouth)
	{
		if (ob->hitsouth == 17)
		{
			ob->y -= 2*PIXGLOBAL;
			ob->top -= 2*PIXGLOBAL;
			ob->xspeed = 0;
			ob->x = CONVERT_TILE_TO_GLOBAL(ob->tilemidx) - 2*PIXGLOBAL;
		}
		else
		{
#ifdef KEEN6
			if (ob->hitsouth == 33)
			{
				FlipBigSwitch(ob, false);
			}
#endif
			if (!jumpcheat)
			{
				SD_PlaySound(SND_HELMETHIT);
				if (ob->hitsouth > 1)
				{
					ob->yspeed += 16;
					if (ob->yspeed < 0)
						ob->yspeed = 0;
				}
				else
				{
					ob->yspeed = 0;
				}
				jumptime = 0;
			}
		}
	}

	if (ob->hitnorth)
	{
		ob->ymove = 0;
		if ((ob->hitnorth & ~7) == 8)
		{
			KillKeen();
		}
		else
		{
#if defined KEEN5
			if (ob->hitnorth == 57)
			{
				SD_PlaySound(SND_LANDONFUSE);
			}
#elif defined KEEN6
			if (ob->hitnorth == 33)
			{
				FlipBigSwitch(ob, true);
			}
#endif
			if (ob->hitnorth != 25 || !jumptime)
			{
				ob->temp1 = ob->temp2 = 0;
				if (ob->state == &s_keenairshoot1)
				{
					ChangeState(ob, &s_keenshoot1);
				}
				else if (ob->state == &s_keenairshootup1)
				{
					ChangeState(ob, &s_keenshootup1);
				}
				else if (c.xaxis)
				{
					ChangeState(ob, &s_keenwalk1);
				}
				else
				{
					ChangeState(ob, &s_keenstand);
				}
				SD_PlaySound(SND_LAND);
			}
		}
	}
	else if (ob->ymove > 0)
	{
		oldtop = ob->top - ob->ymove;
		graby = ((ob->top - 4*PIXGLOBAL) & 0xFF00) + 4*PIXGLOBAL;
		ty = CONVERT_GLOBAL_TO_TILE(graby) - 1;
		if (oldtop < graby && ob->top >= graby)
		{
			if (c.xaxis == -1)
			{
				map = mapsegs[1] + mapbwidthtable[ty]/2 + ob->tileleft;
				if (ob->hiteast)
					map--;
				tile = *map;
				if (!tinf[EASTWALL + tile] && !tinf[WESTWALL + tile]
					&& !tinf[NORTHWALL + tile] && !tinf[SOUTHWALL + tile]
					&& tinf[EASTWALL + map[mapwidth]] && tinf[NORTHWALL + map[mapwidth]]
					)
				{
					ob->xdir = -1;
					ob->needtoclip = false;
					ob->x = (ob->x & 0xFF00) + 8*PIXGLOBAL;
					ob->y = graby - 4*PIXGLOBAL;
					ob->yspeed = ob->ymove = 0;
					ChangeState(ob, &s_keengrabedge1);
				}
			}
			else if (c.xaxis == 1)
			{
				map = mapsegs[1] + mapbwidthtable[ty]/2 + ob->tileright;
				if (ob->hitwest)
					map++;
				tile = *map;
				if (!tinf[EASTWALL + tile] && !tinf[WESTWALL + tile]
					&& !tinf[NORTHWALL + tile] && !tinf[SOUTHWALL + tile]
					&& tinf[WESTWALL + map[mapwidth]] && tinf[NORTHWALL + map[mapwidth]]
					)
				{
					ob->xdir = 1;
					ob->needtoclip = false;
					ob->x = (ob->x & 0xFF00) + 16*PIXGLOBAL;
					ob->y = graby - 4*PIXGLOBAL;
					ob->yspeed = ob->ymove = 0;
					ChangeState(ob, &s_keengrabedge1);
				}
			}
		}
	}
	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

#ifdef KEEN5
void BreakFuse(Uint16 tileX, Uint16 tileY)
{
	Uint16 tiles[] = {1932, 1950};	// should be 'static' for less overhead

	// TODO: there's something fishy going on here:
	_AX = tiles[0];
	_DX = 4;

	SpawnBigSpark(tileX, tileY);
	if (--gamestate.fuses == 0)
	{
		SpawnFinisher();
	}
	RF_MemToMap(tiles, 1, tileX, tileY, 1, 2);
}
#endif

void KeenPogoReact(objtype *ob)
{
	if (ob->hiteast && ob->xdir == -1 || ob->hitwest && ob->xdir == 1)
		ob->xspeed = 0;

	if (ob->hitsouth)
	{
		if (ob->hitsouth == 17)
		{
			ob->y -= 2*PIXGLOBAL;
			ob->top -= 2*PIXGLOBAL;
			ob->xspeed = 0;
			ob->x = CONVERT_TILE_TO_GLOBAL(ob->tilemidx) - 2*PIXGLOBAL;
		}
		else
		{
#ifdef KEEN6
			if (ob->hitsouth == 33)
			{
				FlipBigSwitch(ob, false);
			}
#endif
			if (!jumpcheat)
			{
				SD_PlaySound(SND_HELMETHIT);
				if (ob->hitsouth > 1)
				{
					ob->yspeed += 16;
					if (ob->yspeed < 0)
						ob->yspeed = 0;
				}
				else
				{
					ob->yspeed = 0;
				}
				jumptime = 0;
			}
		}
	}

	if (ob->hitnorth)
	{
		ob->ymove = 0;
		if ((ob->hitnorth & ~7) == 8)
		{
			KillKeen();
		}
		else
		{
#if defined KEEN5
			if (ob->hitnorth == 57)
			{
				if (ob->yspeed < 48)
				{
					SD_PlaySound(SND_LANDONFUSE);
				}
				else
				{
					BreakFuse(ob->tilemidx, ob->tilebottom);
					RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
					return;
				}
			}
#elif defined KEEN6
			if (ob->hitnorth == 33)
			{
				FlipBigSwitch(ob, true);
			}
			else if (ob->hitnorth == 41)
			{
				ob->xspeed += 8;
				if (ob->xspeed > 8)
					ob->xspeed = 8;
			}
			else if (ob->hitnorth == 49)
			{
				ob->xspeed -= 8;
				if (ob->xspeed < -8)
					ob->xspeed = -8;
			}
#endif
			if (ob->hitnorth != 25 || !jumptime)
			{
				ob->yspeed = -48;
				jumptime = 24;
				SD_PlaySound(SND_POGOBOUNCE);
				ChangeState(ob, &s_keenpogo2);
			}
		}
	}
	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

void KeenPoleSlideReact(objtype *ob)
{
	Uint16 far *map;
	Uint16 ymove;

	map = mapsegs[1] + mapbwidthtable[ob->tilebottom]/2 + ob->tilemidx;
	if (tinf[NORTHWALL + *map] == 1)
	{
		ymove = (ob->bottom & 0xFF) + 1;
		ob->y -= ymove;
		ob->bottom -= ymove;
		ob->tilebottom--;
		ob->needtoclip = true;
		ChangeState(ob, &s_keenduck1);
	}
	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}
