/* Return To The Shadowlands Source Code
 * (Based On Reconstructed Commander Keen 4-6 Source Code)
 * Copyright (C) 2021 K1n9_Duk3
 *
 * The code in this file is loosely based on
 * Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include "CK_DEF.H"

/////////////////////////////////////////////////////////////////////////////
// initialized variables:
/////////////////////////////////////////////////////////////////////////////

// (moved into subroutines as static variables)

/////////////////////////////////////////////////////////////////////////////
// uninitialized variables:
/////////////////////////////////////////////////////////////////////////////

char str[80], str2[20];
Uint16 tedlevelnum;
boolean singlestep, jumpcheat, godmode, tedlevel;
boolean nopan, demo, joypad, fixjerky;

/////////////////////////////////////////////////////////////////////////////
// functions:
/////////////////////////////////////////////////////////////////////////////

void MeasureTextBlock(char *text, Uint16 *width, Uint16 *height)
{
	register char *ptr;
	char c;
	Uint16 w, h;
	char strbuf[80];

	*width = *height = 0;
	ptr = &strbuf[0];
	while ((c=*(text++)) != '\0')
	{
		*(ptr++) = c;
		if (c == '\n' || *text == '\0')
		{
			USL_MeasureString(strbuf, &w, &h);
			*height += h;
			if (*width < w)
			{
				*width = w;
			}
			ptr = &strbuf[0];
		}
	}
}

void ShutdownId(void)
{
	US_Shutdown();
	SD_Shutdown();
	IN_Shutdown();
	RF_Shutdown();
	VW_Shutdown();
	CA_Shutdown();
	MM_Shutdown();
}

static void InitGame(void)
{
	static char *ParmStrings[] = {"JERK", ""};
	void MML_UseSpace (Uint16 segstart, Uint16 seglength);

	Uint16 segstart,seglength;
	Sint16 i;

	for (i=1; i < _argc; i++)
	{
		if (US_CheckParm(_argv[i], ParmStrings) == 0)
		{
			fixjerky = true;
		}
	}

	US_TextScreen();
	MM_Startup();
	VW_Startup();
	RF_Startup();
	IN_Startup();
	SD_Startup();
	US_Startup();
	US_UpdateTextScreen();
	CA_Startup();
	US_Setup();
	US_SetLoadSaveHooks(&LoadTheGame, &SaveTheGame, &ResetGame);
	drawcachebox = DrawCacheBox;
	updatecachebox = UpdateCacheBox;
	finishcachebox = FinishCacheBox;

	CA_ClearMarks();
	CA_MarkGrChunk(STARTFONT);
	CA_MarkGrChunk(STARTTILE8);
	CA_MarkGrChunk(STARTTILE8M);
	CA_MarkGrChunk(STATUSLEFTPICM);
	CA_MarkGrChunk(STATUSTOPPICM);
	CA_CacheMarks(NULL);
	MM_SetLock(&grsegs[STARTFONT], true);
	MM_SetLock(&grsegs[STARTTILE8], true);
	MM_SetLock(&grsegs[STARTTILE8M], true);
	MM_SetLock(&grsegs[STATUSLEFTPICM], true);
	MM_SetLock(&grsegs[STATUSTOPPICM], true);
	fontcolor = WHITE;
	US_FinishTextScreen();
	segstart = FP_SEG(&introscn);
	seglength = 4000/16;
	if (FP_OFF(&introscn))
	{
		segstart++;
		seglength--;
	}
	MML_UseSpace (segstart,seglength);
	VW_SetScreenMode(GRMODE);
	//VW_ColorBorder(CYAN);	// RTTS mod: the border color could cause issues and isn't visible in DOSBox anyway
	VW_ClearVideo(BLACK);
}

void Quit(char *error)
{
	Uint16 finscreen;
	if (!error)
	{
		CA_SetAllPurge();
		CA_CacheGrChunk(ORDERSCREEN);
		finscreen = (Uint16)grsegs[ORDERSCREEN];
	}

	if (screenseg)	// RTTS addition
	VW_ClearVideo(BLACK);
	VW_SetLineWidth(40);
	ShutdownId();
	if (error && *error)
	{
		puts(error);
		if (tedlevel)
		{
			getch();
			execlp("TED5.EXE", "TED5.EXE", "/LAUNCH", NULL);
		}
		else if (US_CheckArg("windows"))
		{
			bioskey(0);
		}
		exit(1);
	}
	if (!NoWait)
	{
		movedata(finscreen, 7, 0xB800, 0, 4000);
		gotoxy(1, 24);
		if (US_CheckArg("windows"))
		{
			bioskey(0);
		}
	}
	exit(0);
}

void TEDDeath(void)
{
	ShutdownId();
	execlp("TED5.EXE", "TED5.EXE", "/LAUNCH", NULL);
	exit(1);	// RTTS addition (launching TED5 is probably going to fail...)
}

static void CheckMemory(void)
{
	Uint16 finscreen;

	if (mminfo.nearheap+mminfo.farheap+mminfo.EMSmem+mminfo.XMSmem >= MINMEMORY)
	{
		return;
	}

	CA_CacheGrChunk (OUTOFMEM);
	finscreen = (Uint16)grsegs[OUTOFMEM];
	ShutdownId();
	movedata (finscreen,7,0xb800,0,4000);
	gotoxy (1,24);
	exit(1);
}

static void DemoLoop(void)
{
	static char *ParmStrings[] = {"easy", "normal", "hard", ""};

	register Sint16 i, state;
	Sint16 level;

	if (tedlevel)
	{
		NewGame();
		CA_LoadAllSounds();
		gamestate.mapon = tedlevelnum;
		restartgame = gd_Normal;
		for (i = 1;i < _argc;i++)
		{
			if ( (level = US_CheckParm(_argv[i],ParmStrings)) == -1)
				continue;

			restartgame = gd_Easy+level;
			break;
		}
		GameLoop();
		TEDDeath();
	}
	state = 0;
	playstate = ex_stillplaying;
	while (1)
	{
		switch (state++)
		{
		case 0:
			if (nopan)
			{
				TitleScreen();
			}
			else
			{
				Intro();
			}
			break;
		case 1:
			RunDemo(0);
			break;
		case 2:
			ShowTextCrawl();
			break;
		case 3:
			RunDemo(1);
			break;
		case 4:
			RunHighscoreDemo();
			break;
		case 5:
			RunDemo(2);
			break;
		case 6:
			RunDemo(3);
			state = 0;
			break;
		}
		CheckMenu();
		while (playstate == ex_resetgame || playstate == ex_loadedgame)
		{
			GameLoop();
			RunHighscoreDemo();
			if (playstate == ex_resetgame || playstate == ex_loadedgame)
			{
				continue;	// don't show title screen, go directly to GameLoop();
			}
			TitleScreen();
			///////////////
			// this is completely useless:
			if (playstate == ex_resetgame || playstate == ex_loadedgame)
			{
				continue;
			}
			///////////////
		}
	}
}

void main(void)
{
	InitGame();
	CheckMemory();
	if (NoWait || tedlevel)
		debugmode = true;
#if 0
	// for quick and easy testing:
	if (US_CheckArg("test"))
	{
		// check memory requirements for each level:

		long totalmem = mminfo.mainmem+mminfo.EMSmem+mminfo.XMSmem+4000;	// +4000 because MM always re-uses the introscn space

		CA_OpenDebug();
		NewGame();
		highscoredemo = true;
		gamestate.difficulty = gd_Hard;
		StopMusic();
		for (gamestate.mapon=0; gamestate.mapon<min(NUMMAPS, GAMELEVELS); gamestate.mapon++)
		{
			itoa(gamestate.mapon, str, 10);
			write(debughandle, str, strlen(str));
			if (((long*)(tinf+2))[gamestate.mapon] > 0)
			{
				SetupGameLevel(true);
				write(debughandle, "\t", 1);
				ltoa(totalmem-MM_TotalFree(), str, 10);
				write(debughandle, str, strlen(str));
				write(debughandle, "\t", 1);
				StartMusic(gamestate.mapon);
				ltoa(totalmem-MM_TotalFree(), str, 10);
				StopMusic();
				write(debughandle, str, strlen(str));
			}
			write(debughandle, "\n", 1);
		}
		highscoredemo = false;
		CA_CloseDebug();
		Quit(NULL);
	}
/*
	{
		// test all in-game dialog messages:

		static byte scoutlevels[] = {3, 5, 8, 10, 13, 14, 16, 17};
		int i;

		CA_LoadAllSounds();
		for (i=0; i<sizeof(scoutlevels); i++)
		{
			VW_ClearVideo(0);
			mapon = scoutlevels[i];
			OracleDialog();
		}
		VW_ClearVideo(0);
		LindseyDialog();
		mapon = 12;
		VW_ClearVideo(0);
		LindseyDialog();
		mapon = -1;
		JanitorDialog();
		StopMusic();
	}
*/
#endif

	DemoLoop();
	Quit("Demo loop exited???");
}