#ifndef __GFX_H__
#define __GFX_H__

//#include "VERSION.H"

//////////////////////////////////////
//
// Graphics .H file for .CK4
// not IGRAB-ed :)
//
//////////////////////////////////////

//
// Lump creation macros
//

#define START_LUMP(actualname, dummyname) actualname, dummyname=actualname-1,
#define END_LUMP(actualname, dummyname) dummyname, actualname=dummyname-1,

//
// Amount of each data item
//

//common numbers:
#define NUMCHUNKS    NUMGRCHUNKS
#define NUMFONT      3
#define NUMFONTM     0
#define NUMPICM      3
#define NUMTILE8     104
#define NUMTILE8M    20
#define NUMTILE32    0
#define NUMTILE32M   0

//episode-specific numbers:
#define NUMPICS      115
#define NUMSPRITES   431
#define NUMTILE16    1296
#define NUMTILE16M   2916
#define NUMEXTERNS   16

//
// IMPORTANT:
// Make sure these numbers match your GFX.DEF file for ModId/uGrab!
// Also remember to update the numbers in GFXE_CK4.EQU to match these.
//


//
// File offsets for data items
//
#define STRUCTPIC    0
#define STRUCTPICM   1
#define STRUCTSPRITE 2

#define STARTFONT    3
#define STARTFONTM   (STARTFONT+NUMFONT)
#define STARTPICS    (STARTFONTM+NUMFONTM)
#define STARTPICM    (STARTPICS+NUMPICS)
#define STARTSPRITES (STARTPICM+NUMPICM)
#define STARTTILE8   (STARTSPRITES+NUMSPRITES)
#define STARTTILE8M  (STARTTILE8+1)
#define STARTTILE16  (STARTTILE8M+1)
#define STARTTILE16M (STARTTILE16+NUMTILE16)
#define STARTTILE32  (STARTTILE16M+NUMTILE16M)
#define STARTTILE32M (STARTTILE32+NUMTILE32)
#define STARTEXTERNS (STARTTILE32M+NUMTILE32M)

typedef enum {
	LASTFONT=STARTPICS-1,

	//
	// PICS
	//

	HELPMENUPIC,                 // 6
	LEFTKEYPIC,                  // 7
	RIGHTKEYPIC,                 // 8
	ESCAPEKEYPIC,                // 9
	ENTERKEYPIC,                 // 10
	DUMMYPIC,                    // 11
	STORY1PIC,                   // 12
	STORY2PIC,                   // 13
	STORY3PIC,                   // 14
	STORY4PIC,                   // 15
	STORY5PIC,                   // 16
	STORY6PIC,                   // 17
	STORY7PIC,                   // 18
	STORY8PIC,                   // 19
	ITEM1PIC,                    // 20
	ITEM2PIC,                    // 21
	ITEM3PIC,                    // 22
	ITEM4PIC,                    // 23
	ITEM5PIC,                    // 24
	ITEM6PIC,                    // 25
	ITEM7PIC,                    // 26
	ITEM8PIC,                    // 27
	ITEM9PIC,                    // 28
	ARACHNUTPIC,                 // 29
	BERKELOISPIC,                // 30
	BOUNDERPIC,                  // 31
	COUNCILMEMBERPIC,            // 32
	DOPEFISHPIC,                 // 33
	INCHWORMPIC,                 // 34
	LICKPIC,                     // 35
	MADMUSHROOMPIC,              // 36
	POISONSLIGPIC,               // 37
	PRINCESSLINDSEYPIC,          // 38
	SCHOOLFISHPIC,               // 39
	SKYPESTPIC,                  // 40
	SPRITEPIC,                   // 41
	WORMOUTHPIC,                 // 42
	ENDOFTEXTPIC,                // 43
	MASTERCARDPIC,               // 44
	HELPCURSORPIC,               // 45
	VISAPIC,                     // 46
	TEXTARROW1PIC,               // 47
	TEXTARROW2PIC,               // 48
	ENDINDG1PIC,                 // 49
	ENDINDG2PIC,                 // 50
	ENDINDG3PIC,                 // 51
	ENDINDG4PIC,                 // 52
	ENDINDG5PIC,                 // 53
	ENDINDG6PIC,                 // 54
	ENDINDG7PIC,                 // 55
	ENDINDG8PIC,                 // 56
	ENDINDG9PIC,                 // 57
	ENDINDG10PIC,                // 58
	ENDINDG11PIC,                // 59
	ENDINDG12PIC,                // 60
	ENDINDG13PIC,                // 61
	ENDINDG14PIC,                // 62
	ENDINDG15PIC,                // 63
	ENDINDG16PIC,                // 64
	ENDINDG17PIC,                // 65
	ENDINDG18PIC,                // 66
	ENDINDG19PIC,                // 67
	ENDINDG20PIC,                // 68
	ENDINDG21PIC,                // 69
	ENDINDG22PIC,                // 70
	ENDINDG23PIC,                // 71
	ENDINDG24PIC,                // 72
	ENDINDG25PIC,                // 73
	ENDINDG26PIC,                // 74
	ENDINDG27PIC,                // 75
	ENDINDG28PIC,                // 76
	ENDINDG29PIC,                // 77
	ENDINDG30PIC,                // 78
	IDSOFTWAREPIC,               // 79
	TEXTBORDERTOPPIC,            // 80
	TEXTBORDERLEFTPIC,           // 81
	TEXTBORDERRIGHTPIC,          // 82
	TEXTBORDERBOTTOM1PIC,        // 83
	TEXTBORDERBOTTOM2PIC,        // 84
	BARPIC,                      // 85
	KEEN5PREVIEWPIC,             // 86
	JANITORPIC,                  // 87

	START_LUMP(CONTROLS_LUMP_START, __CONTROLSSTART)
	CP_MAINMENUPIC,              // 88
	CP_NEWGAMEMENUPIC,           // 89
	CP_LOADMENUPIC,              // 90
	CP_SAVEMENUPIC,              // 91
	CP_CONFIGMENUPIC,            // 92
	CP_SOUNDMENUPIC,             // 93
	CP_MUSICMENUPIC,             // 94
	CP_KEYBOARDMENUPIC,          // 95
	CP_KEYMOVEMENTPIC,           // 96
	CP_KEYBUTTONPIC,             // 97
	CP_JOYSTICKMENUPIC,          // 98
	CP_OPTIONSMENUPIC,           // 99
	CP_PADDLEWARPIC,             // 100
	CP_QUITPIC,                  // 101
	CP_JOYSTICKPIC,              // 102
	CP_MENUSCREENPIC,            // 103
	END_LUMP(CONTROLS_LUMP_END, __CONTROLSEND)

	CREDITSPIC1,                 // 104
	CREDITSPIC2,                 // 105
	CREDITSPIC3,                 // 106
	CREDITSPIC4,                 // 107
	TEXTBACKGROUNDPIC,           // 108
	TITLEPIC,                    // 109
	ORACLEPIC,                   // 110
	KEENTALKPIC,                 // 111
	KEENTHUMBPIC,                // 112
	KEENMADPIC,                  // 113
	LINDSEYPIC,                  // 114
	LOADING0PIC,                 // 115
	LOADING1PIC,                 // 116
	LOADING2PIC,                 // 117
	LOADING3PIC,                 // 118
	LOADING4PIC,                 // 119
	LOADING5PIC,                 // 120

	//
	// MASKED PICS
	//

	CP_MENUMASKPICM,             // 121
	STATUSLEFTPICM,              // 122
	STATUSTOPPICM,               // 123

	//
	// SPRITES
	//

	START_LUMP(PADDLE_LUMP_START, __PADDLESTART)
	PADDLESPR,                   // 124
	BALLSPR,                     // 125
	BALL1PIXELTOTHERIGHTSPR,     // 126
	BALL2PIXELSTOTHERIGHTSPR,    // 127
	BALL3PIXELSTOTHERIGHTSPR,    // 128
	END_LUMP(PADDLE_LUMP_END, __PADDLEEND)

	DEMOSPR,                     // 129

	//player lump:
	START_LUMP(KEEN_LUMP_START, __KEENSTART)
	KEENSTANDRSPR,               // 130
	KEENWALKR1SPR,               // 131
	KEENWALKR2SPR,               // 132
	KEENWALKR3SPR,               // 133
	KEENWALKR4SPR,               // 134
	KEENJUMPR1SPR,               // 135
	KEENJUMPR2SPR,               // 136
	KEENJUMPR3SPR,               // 137
	KEENSTANDLSPR,               // 138
	KEENWALKL1SPR,               // 139
	KEENWALKL2SPR,               // 140
	KEENWALKL3SPR,               // 141
	KEENWALKL4SPR,               // 142
	KEENJUMPL1SPR,               // 143
	KEENJUMPL2SPR,               // 144
	KEENJUMPL3SPR,               // 145
	KEENLOOKUPSPR,               // 146
	KEENIDLE1SPR,                // 147
	KEENIDLE2SPR,                // 148
	KEENIDLE3SPR,                // 149
	KEENREAD1SPR,                // 150
	KEENREAD2SPR,                // 151
	KEENREAD3SPR,                // 152
	KEENREAD4SPR,                // 153
	KEENREAD5SPR,                // 154
	KEENREAD6SPR,                // 155
	KEENREAD7SPR,                // 156
	KEENREAD8SPR,                // 157
	KEENREAD9SPR,                // 158
	KEENWATCHSPR,                // 159
	KEENDUCK1SPR,                // 160
	KEENDUCK2SPR,                // 161
	KEENDIE1SPR,                 // 162
	KEENDIE2SPR,                 // 163
	STARS1SPR,                   // 164
	STARS2SPR,                   // 165
	STARS3SPR,                   // 166
	KEENSHOOTLSPR,               // 167
	KEENJSHOOTLSPR,              // 168
	KEENJSHOOTDSPR,              // 169
	KEENJSHOOTUSPR,              // 170
	KEENSHOOTUSPR,               // 171
	KEENSHOOTRSPR,               // 172
	KEENJSHOOTRSPR,              // 173
	KEENSHOT1SPR,                // 174
	KEENSHOT2SPR,                // 175
	KEENSHOT3SPR,                // 176
	KEENSHOT4SPR,                // 177
	KEENSHOTEXPLODE1SPR,         // 178
	KEENSHOTEXPLODE2SPR,         // 179
	KEENSHINNYR1SPR,             // 180
	KEENSHINNYR2SPR,             // 181
	KEENSHINNYR3SPR,             // 182
	KEENSLIDED1SPR,              // 183
	KEENSLIDED2SPR,              // 184
	KEENSLIDED3SPR,              // 185
	KEENSLIDED4SPR,              // 186
	KEENSHINNYL1SPR,             // 187
	KEENSHINNYL2SPR,             // 188
	KEENSHINNYL3SPR,             // 189
	KEENPLSHOOTUSPR,             // 190
	KEENPRSHOOTUSPR,             // 191
	KEENPRSHOOTDSPR,             // 192
	KEENPLSHOOTDSPR,             // 193
	KEENPSHOOTLSPR,              // 194
	KEENPSHOOTRSPR,              // 195
	KEENENTER1SPR,               // 196
	KEENENTER2SPR,               // 197
	KEENENTER3SPR,               // 198
	KEENENTER4SPR,               // 199
	KEENENTER5SPR,               // 200
	KEENGRABLSPR,                // 201
	KEENGRABRSPR,                // 202
	KEENCLIMBL1SPR,              // 203
	KEENCLIMBL2SPR,              // 204
	KEENCLIMBL3SPR,              // 205
	KEENCLIMBL4SPR,              // 206
	KEENCLIMBR1SPR,              // 207
	KEENCLIMBR2SPR,              // 208
	KEENCLIMBR3SPR,              // 209
	KEENCLIMBR4SPR,              // 210
	KEENPOGOR1SPR,               // 211
	KEENPOGOR2SPR,               // 212
	KEENPOGOL1SPR,               // 213
	KEENPOGOL2SPR,               // 214
	DROPSPLASH1SPR,              // 215
	DROPSPLASH2SPR,              // 216
	DROPSPLASH3SPR,              // 217
	BLUE1UPSPR,                  // 218
	BONUS100SPR,                 // 219
	BONUS200SPR,                 // 220
	BONUS500SPR,                 // 221
	BONUS1000SPR,                // 222
	BONUS2000SPR,                // 223
	BONUS5000SPR,                // 224
	BONUS1UPSPR,                 // 225
	BONUSAMMOSPR,                // 226
	END_LUMP(KEEN_LUMP_END, __KEENEND)

	START_LUMP(BONUS100_LUMP_START, __BONUS100START)
	BONUS1001SPR,                // 227
	BONUS1002SPR,                // 228
	END_LUMP(BONUS100_LUMP_END, __BONUS100END)

	START_LUMP(BONUS200_LUMP_START, __BONUS200START)
	BONUS2001SPR,                // 229
	BONUS2002SPR,                // 230
	END_LUMP(BONUS200_LUMP_END, __BONUS200END)

	START_LUMP(BONUS500_LUMP_START, __BONUS500START)
	BONUS5001SPR,                // 231
	BONUS5002SPR,                // 232
	END_LUMP(BONUS500_LUMP_END, __BONUS500END)

	START_LUMP(BONUS1000_LUMP_START, __BONUS1000START)
	BONUS10001SPR,               // 233
	BONUS10002SPR,               // 234
	END_LUMP(BONUS1000_LUMP_END, __BONUS1000END)

	START_LUMP(BONUS2000_LUMP_START, __BONUS2000START)
	BONUS20001SPR,               // 235
	BONUS20002SPR,               // 236
	END_LUMP(BONUS2000_LUMP_END, __BONUS2000END)

	START_LUMP(BONUS5000_LUMP_START, __BONUS5000START)
	BONUS50001SPR,               // 237
	BONUS50002SPR,               // 238
	END_LUMP(BONUS5000_LUMP_END, __BONUS5000END)

	START_LUMP(EXTRALIFE_LUMP_START, __EXTRALIFESTART)
	EXTRALIFE1SPR,               // 239
	EXTRALIFE2SPR,               // 240
	END_LUMP(EXTRALIFE_LUMP_END, __EXTRALIFEEND)

	START_LUMP(KEYGEM_LUMP_START, __KEYGEMSTART)
	KEYGEMRED1SPR,               // 242
	KEYGEMRED2SPR,               // 243
	KEYGEMYELLOW1SPR,            // 244
	KEYGEMYELLOW2SPR,            // 245
	KEYGEMBLUE1SPR,              // 246
	KEYGEMBLUE2SPR,              // 247
	KEYGEMGREEN1SPR,             // 248
	KEYGEMGREEN2SPR,             // 249
	KEYGEMPICKUPSPR,             // 250
	END_LUMP(KEYGEM_LUMP_END, __KEYGEMEND)

	START_LUMP(AMMO_LUMP_START, __AMMOSTART)
	AMMO1SPR,                    // 251
	AMMO2SPR,                    // 252
	END_LUMP(AMMO_LUMP_END, __AMMOEND)

	SCOREBOXSPR,                 // 253

	START_LUMP(WORLDKEEN_LUMP_START, __WORLDKEENSTART)
	WORLDKEENL1SPR,              // 254
	WORLDKEENL2SPR,              // 255
	WORLDKEENL3SPR,              // 256
	WORLDKEENR1SPR,              // 257
	WORLDKEENR2SPR,              // 258
	WORLDKEENR3SPR,              // 259
	WORLDKEENU1SPR,              // 260
	WORLDKEENU2SPR,              // 261
	WORLDKEENU3SPR,              // 262
	WORLDKEEND1SPR,              // 263
	WORLDKEEND2SPR,              // 264
	WORLDKEEND3SPR,              // 265
	WORLDKEENDR1SPR,             // 266
	WORLDKEENDR2SPR,             // 267
	WORLDKEENDR3SPR,             // 268
	WORLDKEENDL1SPR,             // 269
	WORLDKEENDL2SPR,             // 270
	WORLDKEENDL3SPR,             // 271
	WORLDKEENUL1SPR,             // 272
	WORLDKEENUL2SPR,             // 273
	WORLDKEENUL3SPR,             // 274
	WORLDKEENUR1SPR,             // 275
	WORLDKEENUR2SPR,             // 276
	WORLDKEENUR3SPR,             // 277
	WORLDKEENWAVE1SPR,           // 278
	WORLDKEENWAVE2SPR,           // 279
	WORLDKEENSWIMU1SPR,          // 280
	WORLDKEENSWIMU2SPR,          // 281
	WORLDKEENSWIMR1SPR,          // 282
	WORLDKEENSWIMR2SPR,          // 283
	WORLDKEENSWIMD1SPR,          // 284
	WORLDKEENSWIMD2SPR,          // 285
	WORLDKEENSWIML1SPR,          // 286
	WORLDKEENSWIML2SPR,          // 287
	WORLDKEENSWIMUR1SPR,         // 288
	WORLDKEENSWIMUR2SPR,         // 289
	WORLDKEENSWIMDR1SPR,         // 290
	WORLDKEENSWIMDR2SPR,         // 291
	WORLDKEENSWIMDL1SPR,         // 292
	WORLDKEENSWIMDL2SPR,         // 293
	WORLDKEENSWIMUL1SPR,         // 294
	WORLDKEENSWIMUL2SPR,         // 295
	WOLRDKEENRIDE1SPR,           // 296
	WOLRDKEENRIDE2SPR,           // 297
	FLAGTHROW1SPR,               // 298
	FLAGTHROW2SPR,               // 299
	FLAGTHROW3SPR,               // 300
	FLAGTHROW4SPR,               // 301
	FLAGTHROW5SPR,               // 302
	FLAGTHROW6SPR,               // 303
	FLAGTHROW7SPR,               // 304
	FLAG1SPR,                    // 305
	FLAG2SPR,                    // 306
	FLAG3SPR,                    // 307
	FLAG4SPR,                    // 308
	END_LUMP(WORLDKEEN_LUMP_END, __WORLDKEENEND)

	START_LUMP(SCUBAKEEN_LUMP_START, __SCUBAKEENSTART)
	SCUBAKEENL1SPR,              // 309
	SCUBAKEENL2SPR,              // 310
	SCUBAKEENR1SPR,              // 311
	SCUBAKEENR2SPR,              // 312
	SCUBAKEENDEAD1SPR,           // 313
	SCUBAKEENDEAD2SPR,           // 314
	END_LUMP(SCUBAKEEN_LUMP_END, __SCUBAKEENEND)

	START_LUMP(SLUG_LUMP_START, __SLUGSTART)
	SLUGWALKR1SPR,               // 315
	SLUGWALKR2SPR,               // 316
	SLUGPOORSPR,                 // 317
	SLUGSTUNNED1SPR,             // 318
	SLUGSTUNNED2SPR,             // 319
	SLUGWALKL1SPR,               // 320
	SLUGWALKL2SPR,               // 321
	SLUGPOOLSPR,                 // 322
	SLUGSTAIN1SPR,               // 323
	SLUGSTAIN2SPR,               // 324
	END_LUMP(SLUG_LUMP_END, __SLUGEND)

	START_LUMP(MADMUSHROOM_LUMP_START, __MADMUSHROOMSTART)
	MADMUSHROOML1SPR,            // 325
	MADMUSHROOML2SPR,            // 326
	MADMUSHROOMR1SPR,            // 327
	MADMUSHROOMR2SPR,            // 328
	END_LUMP(MADMUSHROOM_LUMP_END, __MADMUSHROOMEND)

	START_LUMP(LINDSEY_LUMP_START, __LINDSEYSTART)
	LINDSEY1SPR,                 // 329
	LINDSEY2SPR,                 // 330
	LINDSEY3SPR,                 // 331
	LINDSEY4SPR,                 // 332
	END_LUMP(LINDSEY_LUMP_END, __LINDSEYEND)

	START_LUMP(INCHWORM_LUMP_START, __INCHWORMSTART)
	INCHWORMR1SPR,               // 333
	INCHWORMR2SPR,               // 334
	INCHWORML1SPR,               // 335
	INCHWORML2SPR,               // 336
	FOOTSPR,                     // 337
	END_LUMP(INCHWORM_LUMP_END, __INCHWORMEND)

	START_LUMP(THIEF_LUMP_START, __THIEFSTART)
	THIEFSTANDRSPR,              // 338
	THIEFSTANDLSPR,              // 339
	THIEFJUMP1RSPR,              // 340
	THIEFJUMP2RSPR,              // 341
	THIEFJUMP3RSPR,              // 342
	THIEFJUMP1LSPR,              // 343
	THIEFJUMP2LSPR,              // 344
	THIEFJUMP3LSPR,              // 345
	ITEMKILLED1SPR,              // 346
	ITEMKILLED2SPR,              // 347
	ITEMKILLED3SPR,              // 348
	ITEMKILLED4SPR,              // 349
	SMOKE1SPR,                   // 350
	SMOKE2SPR,                   // 351
	SMOKE3SPR,                   // 352
	SMOKE4SPR,                   // 353
	SMOKE5SPR,                   // 354
	THIEFSTUNNEDSPR,             // 355
	END_LUMP(THIEF_LUMP_END, __THIEFEND)

	START_LUMP(ORACLE_LUMP_START, __ORACLESTART)
	ORACLEWALK1RSPR,             // 356
	ORACLEWALK2RSPR,             // 357
	ORACLEWALK1LSPR,             // 358
	ORACLEWALK2LSPR,             // 359
	ORACLETHINKLSPR,             // 360
	ORACLETHINKRSPR,             // 361
	END_LUMP(ORACLE_LUMP_END, __ORACLEEND)

	START_LUMP(EGG_LUMP_START, __EGGSTART)
	EGGSPR,                      // 362
	BROKENEGGSPR,                // 363
	EGGPIECE1SPR,                // 364
	EGGPIECE2SPR,                // 365
	EGGPIECE3SPR,                // 366
	END_LUMP(EGG_LUMP_END, __EGGEND)

	START_LUMP(EAGLE_LUMP_START, __EAGLESTART)
	EAGLEWALK1RSPR,              // 367
	EAGLEWALK2RSPR,              // 368
	EAGLEWALK3RSPR,              // 369
	EAGLEWALK4RSPR,              // 370
	EAGLEWALK1LSPR,              // 371
	EAGLEWALK2LSPR,              // 372
	EAGLEWALK3LSPR,              // 373
	EAGLEWALK4LSPR,              // 374
	EAGLEFLY1SPR,                // 375
	EAGLEFLY2SPR,                // 376
	EAGLEFLY3SPR,                // 377
	EAGLEFLY4SPR,                // 378
	EAGLESTUNNEDSPR,             // 379
	END_LUMP(EAGLE_LUMP_END, __EAGLEEND)

	START_LUMP(DARTS_LUMP_START, __DARTSSTART)
	DART1USPR,                   // 380
	DART2USPR,                   // 381
	DART1DSPR,                   // 382
	DART2DSPR,                   // 383
	DART1RSPR,                   // 384
	DART2RSPR,                   // 385
	DART1LSPR,                   // 386
	DART2LSPR,                   // 387
	END_LUMP(DARTS_LUMP_END, __DARTSEND)

	START_LUMP(MIMROCK_LUMP_START, __MIMROCKSTART)
	MIMROCKSPR,                  // 388
	MIMROCKWALK1LSPR,            // 389
	MIMROCKWALK2LSPR,            // 390
	MIMROCKWALK3LSPR,            // 391
	MIMROCKWALK4LSPR,            // 392
	MIMROCKWALK1RSPR,            // 393
	MIMROCKWALK2RSPR,            // 394
	MIMROCKWALK3RSPR,            // 395
	MIMROCKWALK4RSPR,            // 396
	MIMROCKJUMP1RSPR,            // 397
	MIMROCKJUMP2RSPR,            // 398
	MIMROCKJUMP3RSPR,            // 399
	MIMROCKJUMP1LSPR,            // 400
	MIMROCKJUMP2LSPR,            // 401
	MIMROCKJUMP3LSPR,            // 402
	MINROCKSRUNNEDSPR,           // 403
	END_LUMP(MIMROCK_LUMP_END, __MIMROCKEND)

	START_LUMP(DOPEFISH_LUMP_START, __DOPEFISHSTART)
	DOPEFISHSWIMR1SPR,           // 404
	DOPEFISHSWIMR2SPR,           // 405
	DOPEFISHHUNGRYRSPR,          // 406
	DOPEFISHBURP1SPR,            // 407
	DOPEFISHBURP2SPR,            // 408
	BIGBUBBLE1SPR,               // 409
	BIGBUBBLE2SPR,               // 410
	BIGBUBBLE3SPR,               // 411
	BIGBUBBLE4SPR,               // 412
	SMALLBUBBLE1SPR,             // 413
	SMALLBUBBLE2SPR,             // 414
	SMALLBUBBLE3SPR,             // 415
	SMALLBUBBLE4SPR,             // 416
	MEDIUMBUBBLESPR,             // 417
	DOPEFISHSWIML1SPR,           // 418
	DOPEFISHSWIML2SPR,           // 419
	DOPEFISHHUNGRYLSPR,          // 420
	END_LUMP(DOPEFISH_LUMP_END, __DOPEFISHEND)

	START_LUMP(SCHOOLFISH_LUMP_START, __SCHOOLFISHSTART)
	SCHOOLFISHL1SPR,             // 421
	SCHOOLFISHL2SPR,             // 422
	SCHOOLFISHR1SPR,             // 423
	SCHOOLFISHR2SPR,             // 424
	END_LUMP(SCHOOLFISH_LUMP_END, __SCHOOLFISHEND)

	START_LUMP(ARACHNUT_LUMP_START, __ARACHNUTSTART)
	ARACHNUTWALK1SPR,            // 425
	ARACHNUTWALK2SPR,            // 426
	ARACHNUTWALK3SPR,            // 427
	ARACHNUTWALK4SPR,            // 428
	ARACHNUTSTUNNEDSPR,          // 429
	END_LUMP(ARACHNUT_LUMP_END, __ARACHNUTEND)

	WETSUITSPR,                  // 430

	START_LUMP(SPRITE_LUMP_START, __SPRITESTART)
	SPRITEFLOATSPR,              // 431
	SPRITEAIMLSPR,               // 432
	SPRITESHOOTLSPR,             // 433
	SPRITEAIMRSPR,               // 434
	SPRITESHOOTRSPR,             // 435
	SPRITESHOT1SPR,              // 436
	SPRITESHOT2SPR,              // 437
	SPRITESHOT3SPR,              // 438
	SPRITESHOT4SPR,              // 439
	END_LUMP(SPRITE_LUMP_END, __SPRITEEND)

	START_LUMP(MINE_LUMP_START, __MINESTART)
	MINESPR,                     // 440
	MINEEXPLODE1SPR,             // 441
	MINEEXPLODE2SPR,             // 442
	END_LUMP(MINE_LUMP_END, __MINEEND)

	START_LUMP(SKYPEST_LUMP_START, __SKYPESTSTART)
	SKYPESTFLY1LSPR,             // 443
	SKYPESTFLY2LSPR,             // 444
	SKYPESTFLY1RSPR,             // 445
	SKYPESTFLY2RSPR,             // 446
	SKYPESTSIT1SPR,              // 447
	SKYPESTSIT2SPR,              // 448
	SKYPESTSIT3SPR,              // 449
	SKYPESTSIT4SPR,              // 450
	SKYPESTSIT5SPR,              // 451
	SKYPESTSIT6SPR,              // 452
	SKYPESTSIT7SPR,              // 453
	SKYPESTSIT8SPR,              // 454
	SKYPESTSIT9SPR,              // 455
	SKYPESTSQUISHEDSPR,          // 456
	END_LUMP(SKYPEST_LUMP_END, __SKYPESTEND)

	START_LUMP(WORMOUTH_LUMP_START, __WORMOUTHSTART)
	WORMOUTHSPR,                 // 457
	WORMOUTHLOOK1RSPR,           // 458
	WORMOUTHLOOK2RSPR,           // 459
	WORMOUTHLOOK1LSPR,           // 460
	WORMOUTHLOOK2LSPR,           // 461
	WORMOUTHATTACK1RSPR,         // 462
	WORMOUTHATTACK2RSPR,         // 463
	WORMOUTHATTACK3RSPR,         // 464
	WORMOUTHATTACK1LSPR,         // 465
	WORMOUTHATTACK2LSPR,         // 466
	WORMOUTHATTACK3LSPR,         // 467
	WORMOUTHSTUNNEDSPR,          // 468
	END_LUMP(WORMOUTH_LUMP_END, __WORMOUTHEND)

	START_LUMP(LICK_LUMP_START, __LICKSTART)
	LICKMOVE1RSPR,               // 469
	LICKMOVE2RSPR,               // 470
	LICKMOVE3RSPR,               // 471
	LICKMOVE4RSPR,               // 472
	LICKMOVE1LSPR,               // 473
	LICKMOVE2LSPR,               // 474
	LICKMOVE3LSPR,               // 475
	LICKMOVE4LSPR,               // 476
	LICKATTACK1RSPR,             // 477
	LICKATTACK2RSPR,             // 478
	LICKATTACK3RSPR,             // 479
	LICKATTACK1LSPR,             // 480
	LICKATTACK2LSPR,             // 481
	LICKATTACK3LSPR,             // 482
	LICKSTUNNEDSPR,              // 483
	END_LUMP(LICK_LUMP_END, __LICKEND)

	START_LUMP(PLATFORM_LUMP_START, __PLATFORMSTART)
	PLATFORMSPR,                 // 484
	PLATSIDETHRUST1SPR,          // 485
	PLATSIDETHRUST2SPR,          // 486
	PLATRTHRUST1SPR,             // 487
	PLATRTHRUST2SPR,             // 488
	PLATLTHRUST1SPR,             // 489
	PLATLTHRUST2SPR,             // 490
	END_LUMP(PLATFORM_LUMP_END, __PLATFORMEND)

	START_LUMP(BOUNDER_LUMP_START, __BOUNDERSTART)
	BOUNDER1LSPR,                // 491
	BOUNDER2LSPR,                // 492
	BOUNDER1RSPR,                // 493
	BOUNDER2RSPR,                // 494
	BOUNDER1CSPR,                // 495
	BOUNDER2CSPR,                // 496
	BOUNDERSTUNNEDSPR,           // 497
	END_LUMP(BOUNDER_LUMP_END, __BOUNDEREND)

	START_LUMP(THUNDERCLOUD_LUMP_START, __THUNDERCLOUDSTART)
	CLOUDSPR,                    // 498
	CLOUDACTIVESPR,              // 499
	CLOUDCHARGESPR,              // 500
	LIGHTNING1SPR,               // 501
	LIGHTNING2SPR,               // 502
	END_LUMP(THUNDERCLOUD_LUMP_END, __THUNDERCLOUDEND)

	START_LUMP(BERKELOID_LUMP_START, __BERKELOIDSTART)
	BERKELOIDWALKL1SPR,          // 503
	BERKELOIDWALKL2SPR,          // 504
	BERKELOIDWALKL3SPR,          // 505
	BERKELOIDWALKL4SPR,          // 506
	BERKELOIDWALKR1SPR,          // 507
	BERKELOIDWALKR2SPR,          // 508
	BERKELOIDWALKR3SPR,          // 509
	BERKELOIDWALKR4SPR,          // 510
	BERKELOIDATTACKL1SPR,        // 511
	BERKELOIDATTACKL2SPR,        // 512
	BERKELOIDATTACKR1SPR,        // 513
	BERKELOIDATTACKR2SPR,        // 514
	FIREBALL1SPR,                // 515
	FIREBALL2SPR,                // 516
	FIREBALL3SPR,                // 517
	FIREBALL4SPR,                // 518
	END_LUMP(BERKELOID_LUMP_END, __BERKELOIDEND)

	START_LUMP(MOON_LUMP_START, __MOONSTART)
	KEENMOON1SPR,                // 519
	KEENMOON2SPR,                // 520
	END_LUMP(MOON_LUMP_END, __MOONEND)

	START_LUMP(BADOING_LUMP_START, __BADOINGSTART)
	BADOINGHIDDENSPR,
	BADOINGRISE1SPR,
	BADOINGRISE2SPR,
	BADOINGRISE3SPR,
	BADOINGRISE4SPR,
	BADOINGTURNLSPR,
	BADOINGLOOKLSPR,
	BADOINGTURNRSPR,
	BADOINGLOOKRSPR,
	BADOINGSTUNNEDSPR,
	END_LUMP(BADOING_LUMP_END, __BADOINGEND)

	START_LUMP(WITCHDOC_LUMP_START, __WITCHDOCSTART)
	WITCHDOCWALKL1SPR,
	WITCHDOCWALKL2SPR,
	WITCHDOCWALKR1SPR,
	WITCHDOCWALKR2SPR,
	END_LUMP(WITCHDOC_LUMP_END, __WITCHDOCEND)

	START_LUMP(JANITOR_LUMP_START, __JANITORSTART)
	JANITORWALK1RSPR,
	JANITORWALK2RSPR,
	JANITORWALK1LSPR,
	JANITORWALK2LSPR,
	JANITORTHINKLSPR,
	JANITORTHINKRSPR,
	END_LUMP(JANITOR_LUMP_END, __JANITOREND)

	START_LUMP(STINGARU_LUMP_START, __STINGARUSTART)
	STINGARUWALKL1SPR,
	STINGARUWALKL2SPR,
	STINGARUWALKL3SPR,
	STINGARUWALKL4SPR,
	STINGARUJUMPL1SPR,
	STINGARUJUMPL2SPR,
	STINGARUJUMPL3SPR,
	STINGARUSTUNNEDSPR,
	STINGARUWALKR1SPR,
	STINGARUWALKR2SPR,
	STINGARUWALKR3SPR,
	STINGARUWALKR4SPR,
	STINGARUJUMPR1SPR,
	STINGARUJUMPR2SPR,
	STINGARUJUMPR3SPR,
	END_LUMP(STINGARU_LUMP_END, __STINGARUEND)

	//
	// TILES (these don't need names)
	//

	LASTTILE=STARTEXTERNS-1,

	//
	// EXTERNS
	//

	ORDERSCREEN,                 // 4735
	COMMANDERSHAPE,              // 4736
	KEENSHAPE,                   // 4737
	OUTOFMEM,                    // 4738

	//texts
	COMPUTERWRISTTEXT,           // 4739
	STORYTEXT,                   // 4740
	GAMEHELPTEXT,                // 4741
	ABOUTIDTEXT,                 // 4742
	ENDINGTEXT,                  // 4743
	DEMOTEXT,                    // 4744
	ORDERTEXT,                   // 4745

	//demos
	DEMO1,                       // 4746
	DEMO2,                       // 4747
	DEMO3,                       // 4748
	DEMO4,                       // 4749
	DEMO5,                       // 4750

	NUMGRCHUNKS
} graphicnums;

#undef START_LUMP
#undef END_LUMP

#endif //__GFX_H__