/* Return To The Shadowlands Source Code
 * (Based On Reconstructed Commander Keen 4-6 Source Code)
 * Copyright (C) 2021 K1n9_Duk3
 *
 * The code in this file is loosely based on
 * Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/*
K4_ACT3.C
=========

Contains the following actor types (in this order):

- Treasure Eater
- Mimrock
- Dopefish
- Schoolfish
- Sprite
- Mine
- Lindsey
- Dart Shooter & Dart
- Wetsuit

*/

#include "CK_DEF.H"

/*
=============================================================================
	TREASURE EATER

	temp1 - turn counter
=============================================================================
*/

statetype s_treasureeater1 = {THIEFSTANDRSPR, THIEFSTANDRSPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeater2};
statetype s_treasureeater2 = {THIEFSTANDLSPR, THIEFSTANDLSPR, step, false, push_none, 20, 0, 0, TreasureeaterThink, TreasureeaterContact, DrawReact, NULL};
statetype s_treasureeatervanish1 = {SMOKE1SPR, SMOKE1SPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeatervanish2};
statetype s_treasureeatervanish2 = {SMOKE2SPR, SMOKE2SPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeatervanish3};
statetype s_treasureeatervanish3 = {SMOKE3SPR, SMOKE3SPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeatervanish4};
statetype s_treasureeatervanish4 = {SMOKE4SPR, SMOKE4SPR, step, false, push_none, 20, 0, 0, TreasureeaterVanishThink, TreasureeaterContact, DrawReact, &s_treasureeatervanish5};
statetype s_treasureeatervanish5 = {SMOKE4SPR, SMOKE4SPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeatervanish6};
statetype s_treasureeatervanish6 = {SMOKE3SPR, SMOKE3SPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeatervanish7};
statetype s_treasureeatervanish7 = {SMOKE2SPR, SMOKE2SPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeatervanish8};
statetype s_treasureeatervanish8 = {SMOKE1SPR, SMOKE1SPR, step, false, push_none, 20, 0, 0, NULL, TreasureeaterContact, DrawReact, &s_treasureeaterjump1};
statetype s_treasureeaterjump1 = {THIEFJUMP1LSPR, THIEFJUMP1RSPR, stepthink, false, push_none, 6, 0, 0, ProjectileThink3, TreasureeaterContact, TreasureeaterJumpReact, &s_treasureeaterjump2};
statetype s_treasureeaterjump2 = {THIEFJUMP2LSPR, THIEFJUMP2RSPR, stepthink, false, push_none, 6, 0, 0, ProjectileThink3, TreasureeaterContact, TreasureeaterJumpReact, &s_treasureeaterjump3};
statetype s_treasureeaterjump3 = {THIEFJUMP3LSPR, THIEFJUMP3RSPR, stepthink, false, push_none, 6, 0, 0, ProjectileThink3, TreasureeaterContact, TreasureeaterJumpReact, &s_treasureeaterjump4};
statetype s_treasureeaterjump4 = {THIEFJUMP2LSPR, THIEFJUMP2RSPR, stepthink, false, push_none, 6, 0, 0, ProjectileThink3, TreasureeaterContact, TreasureeaterJumpReact, &s_treasureeaterjump1};
statetype s_treasureeaterstunned1 = {THIEFJUMP1LSPR, THIEFJUMP1LSPR, think, false, push_none, 0, 0, 0, ProjectileThink4, 0, StunnedReact, &s_treasureeaterstunned2};
statetype s_treasureeaterstunned2 = {THIEFSTUNNEDSPR, THIEFSTUNNEDSPR, think, false, push_none, 0, 0, 0, ProjectileThink4, 0, StunnedReact, NULL};

statetype s_killedbonus1  = {ITEMKILLED1SPR, ITEMKILLED1SPR, slide, false, push_none, 10, 0, 8, NULL, NULL, DrawReact, &s_killedbonus2};
statetype s_killedbonus2  = {ITEMKILLED2SPR, ITEMKILLED2SPR, slide, false, push_none, 10, 0, 8, NULL, NULL, DrawReact, &s_killedbonus3};
statetype s_killedbonus3  = {ITEMKILLED3SPR, ITEMKILLED3SPR, slide, false, push_none, 10, 0, 8, NULL, NULL, DrawReact, &s_killedbonus4};
statetype s_killedbonus4  = {ITEMKILLED4SPR, ITEMKILLED4SPR, slide, false, push_none, 10, 0, 8, NULL, NULL, DrawReact, NULL};

void SpawnTreasureeater(Sint16 x, Sint16 y)
{
	GetNewObj(false);
	new->obclass = treasureeaterobj;
	new->active = yes;
	new->priority = 3;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = CONVERT_TILE_TO_GLOBAL(y) - 24*PIXGLOBAL;
	if (US_RndT() < 0x80)
	{
		new->xdir = 1;
	}
	else
	{
		new->xdir = -1;
	}
	new->ydir = 1;
	NewState(new, &s_treasureeater1);
}

// can only eat bonus objects and only if they aren't key gems: (RTTS addition)
#define CanEatObject(ob) ((ob)->obclass == bonusobj && (ob)->temp1 >= 4)

void TreasureeaterThink(objtype *ob)
{
	objtype *ob2;
	Uint16 x;
	Sint16 y;
	Uint16 far *map;
	Uint16 intile, rowdiff, width;

	ob->state = &s_treasureeaterjump1;

	//jump straight up if below bonus object:
	for (ob2 = player->next; ob2; ob2 = ob2->next)
	{
		if (CanEatObject(ob2) && ob2->active == yes
			&& ob2->right > ob->left && ob2->left < ob->right
			&& ob2->bottom < ob->top && ob2->bottom + 3*TILEGLOBAL > ob->top)
		{
			ob->xspeed = 0;
			ob->yspeed = -48;
			return;
		}
	}

	//jump straight up if below bonus tile:
	map = mapsegs[1] + mapbwidthtable[ob->tiletop-3]/2 + ob->tileleft;
	width = ob->tileright-ob->tileleft+1;
	rowdiff = mapwidth-width;
	for (y=0; y<3; y++, map+=rowdiff)
	{
		for (x=0; x<width; x++, map++)
		{
			intile = tinf[INTILE+*map];	// BUG? foreground bit isn't masked off!
			if (intile == INTILE_LIFECRUMB || intile >= INTILE_BONUS100 && intile <= INTILE_AMMO)
			{
				ob->xspeed = 0;
				ob->yspeed = -48;
				return;
			}
		}
	}

	//vanish after having checked both directions:
	if (ob->temp1 >= 2)
	{
		ob->state = &s_treasureeatervanish1;
		return;
	}

	//jump in current direction if there is a floor in that direction:
	map = mapsegs[1] + mapbwidthtable[ob->tilebottom-2]/2 + ob->tilemidx;
	map += ob->xdir * 4;
	for (y=0; y<4; y++, map+=mapwidth)
	{
		if (tinf[NORTHWALL+*map])
		{
			ob->xspeed = ob->xdir * 20;
			ob->yspeed = -24;
			return;
		}
	}

	//couldn't jump in current direction, so turn around:
	ob->temp1++;	// increase turn counter
	if (ob->temp1 == 2)	// has turned around twice, so both directions have been checked
	{
		SD_PlaySound(SND_TREASUREEATERVANISH);
		ob->state = &s_treasureeatervanish1;
		return;
	}

	//jump in opposite direction:
	ob->xdir = -ob->xdir;
	ob->xspeed = ob->xdir * 20;
	ob->yspeed = -24;
}

void TreasureeaterVanishThink(objtype *ob)
{
	// heavily modified for RTTS:
	objtype *ob2;
	objtype *nearest = NULL;
	Uint16 bestdist = -1;

	ob->temp1 = 0;
	for (ob2=player->next; ob2; ob2=ob2->next)
	{
		if (CanEatObject(ob2))
		{
			Uint16 xdist, ydist;
			Uint16 dist;
			
			xdist = (Uint16)abs(ob2->x - ob->x) >> 1;
			ydist = (Uint16)abs(ob2->y - ob->y) >> 1;
			dist = xdist + ydist;	// Manhattan distance - prefer straight lines over diagonals
			if (!nearest || dist < bestdist)
			{
				nearest = ob2;
				bestdist = dist;
			}
		}
	}

	if (nearest)
	{
		ob->x = nearest->x - 8*PIXGLOBAL;
		ob->y = nearest->y;
		NewState(ob, &s_treasureeatervanish5);
		return;
	}
	RemoveObj(ob);
}

void TreasureeaterContact(objtype *ob, objtype *hit)
{
	if (CanEatObject(hit))
	{
		hit->obclass = decoobj;
		hit->priority = 3;
		ChangeState(hit, &s_killedbonus1);
		SD_PlaySound(SND_EATBONUS);
	}
	else if (hit->obclass == shotobj)
	{
		//basically StunContact(), but in different order:
		ob->temp1 = 0;
		ob->temp2 = 0;
		ob->temp3 = 0;
		ob->temp4 = ob->obclass;
		ob->obclass = stunnedobj;
		ExplodeShot(hit);
		ChangeState(ob, &s_treasureeaterstunned1);

		ob->yspeed -= 16;
	}
}

void TreasureeaterCheckTiles(objtype *ob)
{
	Uint16 x, y;
	Uint16 far *map;
	Uint16 rowdiff, intile;

	map = mapsegs[1] + mapbwidthtable[ob->tiletop]/2 + ob->tileleft;
	rowdiff = mapwidth-(ob->tileright-ob->tileleft+1);
	for (y=ob->tiletop; y<=ob->tilebottom; y++, map+=rowdiff)
	{
		for (x=ob->tileleft; x<=ob->tileright; x++, map++)
		{
			intile = tinf[INTILE + *map] & INTILE_TYPEMASK;
			if (intile == INTILE_LIFECRUMB || intile >= INTILE_BONUS100 && intile <= INTILE_AMMO)
			{
				RF_MemToMap(&emptytile, 1, x, y, 1, 1);
				GetNewObj(true);
				new->obclass = decoobj;
				new->priority = 3;
				new->needtoclip = false;
				new->x = CONVERT_TILE_TO_GLOBAL(x);
				new->y = CONVERT_TILE_TO_GLOBAL(y);
				new->active = removable;
				ChangeState(new, &s_killedbonus1);	//using ChangeState and not NewState is fine for noclipping objects
				//BUG? this doesn't play a sound
				SD_PlaySound(SND_EATBONUS);	// RTTS addition
				break;
			}
		}
	}
}

void TreasureeaterJumpReact(objtype *ob)
{
	TreasureeaterCheckTiles(ob);

	if (ob->hiteast || ob->hitwest || (Uint16)ob->hitnorth > 1)	// RTTS addition: also turn when standing on a slope
	{
		ob->temp1++;
		ob->xdir = -ob->xdir;
		ob->xspeed = 0;
	}

	if (ob->hitnorth || ob->hitsouth)	// RTTS addition: also reset speed when hitting the ceiling
		ob->yspeed = 0;

	// RTTS mod: change state AFTER the other checks (state change clears the hitnorth field)
	if (ob->hitnorth)
		ChangeState(ob, &s_treasureeater1);

	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

/*
=============================================================================
	MIMROCK
=============================================================================
*/

statetype s_mimrock       = {MIMROCKSPR, MIMROCKSPR, step, false, push_down, 20, 0, 0, MimrockThink, NULL, WalkReact, &s_mimrock};
statetype s_mimrockwalk1  = {MIMROCKWALK1RSPR, MIMROCKWALK1LSPR, step, false, push_down, 6, 64, 0, MimrockWalkThink, MimrockWalkContact, WalkReact, &s_mimrockwalk2};
statetype s_mimrockwalk2  = {MIMROCKWALK2RSPR, MIMROCKWALK2LSPR, step, false, push_down, 6, 64, 0, MimrockWalkThink, MimrockWalkContact, WalkReact, &s_mimrockwalk3};
statetype s_mimrockwalk3  = {MIMROCKWALK3RSPR, MIMROCKWALK3LSPR, step, false, push_down, 6, 64, 0, MimrockWalkThink, MimrockWalkContact, WalkReact, &s_mimrockwalk4};
statetype s_mimrockwalk4  = {MIMROCKWALK4RSPR, MIMROCKWALK4LSPR, step, false, push_down, 6, 64, 0, MimrockWalkThink, MimrockWalkContact, WalkReact, &s_mimrockwalk5};
statetype s_mimrockwalk5  = {MIMROCKWALK1RSPR, MIMROCKWALK1LSPR, step, false, push_down, 6, 64, 0, MimrockWalkThink, MimrockWalkContact, WalkReact, &s_mimrockwalk6};
statetype s_mimrockwalk6  = {MIMROCKWALK2RSPR, MIMROCKWALK2LSPR, step, false, push_down, 6, 64, 0, MimrockWalkThink, MimrockWalkContact, WalkReact, &s_mimrock};
statetype s_mimrockjump1  = {MIMROCKJUMP1LSPR, MIMROCKJUMP1RSPR, stepthink, false, push_none, 24, 0, 0, ProjectileThink3, MimrockJumpContact, MimrockJumpReact, &s_mimrockjump2};
statetype s_mimrockjump2  = {MIMROCKJUMP2LSPR, MIMROCKJUMP2RSPR, stepthink, false, push_none, 10, 0, 0, ProjectileThink3, MimrockJumpContact, MimrockJumpReact, &s_mimrockjump3};
statetype s_mimrockjump3  = {MIMROCKJUMP3LSPR, MIMROCKJUMP3RSPR, think, false, push_none, 10, 0, 0, ProjectileThink3, MimrockJumpContact, MimrockJumpReact, &s_mimrockjump2};
statetype s_mimrockbounce = {MIMROCKJUMP3LSPR, MIMROCKJUMP3RSPR, think, false, push_none, 10, 0, 0, ProjectileThink4, MimrockWalkContact, MimrockBounceReact, NULL};
statetype s_mimrockstunned1 = {MIMROCKJUMP3LSPR, MIMROCKJUMP3LSPR, think, false, push_none, 12, 0, 0, ProjectileThink4, NULL, StunnedReact, &s_mimrockstunned2};
statetype s_mimrockstunned2 = {MINROCKSRUNNEDSPR, MINROCKSRUNNEDSPR, think, false, push_none, 12, 0, 0, ProjectileThink4, NULL, StunnedReact, NULL};

void SpawnMimrock(Sint16 x, Sint16 y)
{
	GetNewObj(false);
	new->obclass = mimrockobj;
	new->active = yes;
	new->priority = 3;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = CONVERT_TILE_TO_GLOBAL(y)+ -13*PIXGLOBAL;
	new->xdir = new->ydir = 1;
	NewState(new, &s_mimrock);
}

void MimrockThink(objtype *ob)
{
	if (abs(ob->bottom - player->bottom) <= 5*TILEGLOBAL
		&& abs(ob->x - player->x) > 3*TILEGLOBAL)
	{
		if (player->x < ob->x)
		{
			if (player->xdir == -1)
			{
				ob->xdir = -1;
				ob->state = &s_mimrockwalk1;
			}
		}
		else
		{
			if (player->xdir == 1)
			{
				ob->xdir = 1;
				ob->state = &s_mimrockwalk1;
			}
		}
	}
}

void MimrockWalkThink(objtype *ob)
{
	if (abs(ob->bottom - player->bottom) > 5*TILEGLOBAL
		|| ob->xdir != player->xdir)
	{
		ob->state = &s_mimrock;
	}
	else if (abs(ob->x - player->x) < 4*TILEGLOBAL)
	{
		ob->xspeed = ob->xdir * 20;
		ob->yspeed = -40;
		tmp_ymove = ob->yspeed * tics;
		ob->state = &s_mimrockjump1;
	}
}

void MimrockWalkContact(objtype *ob, objtype *hit)
{
	if (hit->obclass == shotobj)
	{
		//basically StunContact(), but in different order:
		ob->temp1 = 0;
		ob->temp2 = 0;
		ob->temp3 = 0;
		ob->temp4 = ob->obclass;
		ob->obclass = stunnedobj;
		ExplodeShot(hit);
		ChangeState(ob, &s_mimrockstunned1);

		ob->yspeed -= 16;
	}
}

void MimrockJumpContact(objtype *ob, objtype *hit)
{
	if (hit->obclass == keenobj)
	{
		KillKeen();
	}
	else
	{
		MimrockWalkContact(ob, hit);
	}
}

void MimrockJumpReact(objtype *ob)
{
	if (ob->hitnorth)
	{
		SD_PlaySound(SND_HELMETHIT);
		ob->yspeed = -20;
		ChangeState(ob, &s_mimrockbounce);
	}

	if (ob->hiteast || ob->hitwest)
		ob->xspeed = 0;

	if (ob->hitnorth || ob->hitsouth)
		ob->yspeed = 0;

	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

void MimrockBounceReact(objtype *ob)
{
	if (ob->hitnorth)
	{
		SD_PlaySound(SND_HELMETHIT);
		ChangeState(ob, &s_mimrock);
	}

	if (ob->hiteast || ob->hitwest)
		ob->xspeed = 0;

	if (ob->hitnorth)
		ob->yspeed = 0;

	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

/*
=============================================================================
	DOPEFISH

	temp1 - blocked (cannot seek Keen while this is non-zero)
	temp2 - old x position
	temp3 - old y position
	temp4 - pointer to object being eaten (BUG: may be invalid after loading a saved game!)
=============================================================================
*/

statetype s_dopefishswim1 = {DOPEFISHSWIML1SPR, DOPEFISHSWIMR1SPR, stepthink, false, push_none, 20, 0, 0, DopefishSwimThink, DopefishContact, FishReact, &s_dopefishswim2};
statetype s_dopefishswim2 = {DOPEFISHSWIML2SPR, DOPEFISHSWIMR2SPR, stepthink, false, push_none, 20, 0, 0, DopefishSwimThink, DopefishContact, FishReact, &s_dopefishswim1};
statetype s_dopefishhungry = {DOPEFISHHUNGRYLSPR, DOPEFISHHUNGRYRSPR, think, false, push_none, 0, 0, 0, DopefishHungryThink, NULL, DrawReact, NULL};
statetype s_dopefishpreburp = {DOPEFISHSWIML1SPR, DOPEFISHSWIMR1SPR, step, false, push_none, 60, 0, 0, NULL, NULL, DrawReact, &s_dopefishburp1};
statetype s_dopefishburp1 = {DOPEFISHBURP1SPR, DOPEFISHBURP1SPR, step, false, push_none, 60, 0, 0, DopefishBurpThink, NULL, DrawReact, &s_dopefishburp2};
statetype s_dopefishburp2 = {DOPEFISHBURP2SPR, DOPEFISHBURP2SPR, step, false, push_none, 60, 0, 0, NULL, NULL, DrawReact, &s_dopefishafterburp};
statetype s_dopefishafterburp = {DOPEFISHSWIML1SPR, DOPEFISHSWIMR1SPR, think, false, push_none, 0, 0, 0, DopefishAfterBurpThink, NULL, DrawReact, &s_dopefishswim1};
statetype s_schoolfishswallowed = {SCHOOLFISHL1SPR, SCHOOLFISHR1SPR, think, false, push_none, 0, 0, 0, NULL, NULL, DrawReact, NULL};
statetype s_scubakeenswallowed1 = {SCUBAKEENDEAD1SPR, SCUBAKEENDEAD1SPR, think, false, push_none, 0, 0, 0, NULL, NULL, DrawReact, &s_scubakeenswallowed2};
statetype s_scubakeenswallowed2 = {-1, -1, step, false, push_none, 180, 0, 0, ScubaKeenSwallowedThink, NULL, DrawReact, &s_scubakeenswallowed2};
statetype s_bubble1       = {BIGBUBBLE1SPR, BIGBUBBLE1SPR, think, false, push_none, 20, 0, 20, BubbleThink, NULL, DrawReact, &s_bubble2};
statetype s_bubble2       = {BIGBUBBLE2SPR, BIGBUBBLE2SPR, think, false, push_none, 20, 0, 20, BubbleThink, NULL, DrawReact, &s_bubble3};
statetype s_bubble3       = {BIGBUBBLE3SPR, BIGBUBBLE3SPR, think, false, push_none, 20, 0, 20, BubbleThink, NULL, DrawReact, &s_bubble4};
statetype s_bubble4       = {BIGBUBBLE4SPR, BIGBUBBLE4SPR, think, false, push_none, 20, 0, 20, BubbleThink, NULL, DrawReact, &s_bubble1};

void SpawnDopefish(Sint16 x, Sint16 y)
{
	GetNewObj(false);
	new->obclass = dopefishobj;
	new->active = yes;
	new->priority = 2;
	new->needtoclip = FULLCLIP;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = CONVERT_TILE_TO_GLOBAL(y) + -3*TILEGLOBAL;
	if (US_RndT() < 0x80)
	{
		new->xdir = 1;
	}
	else
	{
		new->xdir = -1;
	}
	new->ydir = 1;
	NewState(new, &s_dopefishswim1);
}

void ScubaKeenSwallowedThink(objtype *ob)
{
	ob++;
	playstate = ex_died;
}

void DopefishSwimThink(objtype *ob)
{
	if (ob->temp1 == 0)
	{
		if (ob->x < player->x)
		{
			ob->xdir = 1;
		}
		else
		{
			ob->xdir = -1;
		}
	}
	AccelerateX_0(ob, ob->xdir, 10);

	if (ob->y < player->y)
	{
		AccelerateY(ob, 1, 10);
	}
	else
	{
		AccelerateY(ob, -1, 10);
	}
}

void DopefishHungryThink(objtype *ob)
{
	objtype *target;
	Sint16 xdist, ydist;

	target = (objtype *)(ob->temp4);
	ydist = target->y - TILEGLOBAL - ob->y;
	if (ob->xdir == 1)
	{
		xdist = target->right + 2*PIXGLOBAL - ob->right;
	}
	else
	{
		xdist = target->left - 2*PIXGLOBAL - ob->left;
	}

	if (xdist < 0)
	{
		tmp_xmove = tics * -32;
		if (tmp_xmove < xdist)
			tmp_xmove = xdist;
	}
	else
	{
		tmp_xmove = tics * 32;
		if (tmp_xmove > xdist)
			tmp_xmove = xdist;
	}

	if (ydist < 0)
	{
		tmp_ymove = tics * -32;
		if (tmp_ymove < ydist)
			tmp_ymove = ydist;
	}
	else
	{
		tmp_ymove = tics * 32;
		if (tmp_ymove > ydist)
			tmp_ymove = ydist;
	}

	if (tmp_xmove == xdist && tmp_ymove == ydist)
	{
		if (target == player)
		{
			ChangeState(target, &s_scubakeenswallowed2);
		}
		else if (target->state->nextstate)
		{
			ChangeState(target, target->state->nextstate);
		}
		else
		{
			RemoveObj(target);
		}
		ob->state = &s_dopefishpreburp;
	}
}

void DopefishAfterBurpThink(objtype *ob)
{
	Sint16 xdist, ydist;

	ydist = ob->temp3 - ob->y;
	xdist = ob->temp2 - ob->x;

	if (xdist < 0)
	{
		tmp_xmove = tics * -32;
		if (tmp_xmove < xdist)
			tmp_xmove = xdist;
	}
	else
	{
		tmp_xmove = tics * 32;
		if (tmp_xmove > xdist)
			tmp_xmove = xdist;
	}

	if (ydist < 0)
	{
		tmp_ymove = tics * -32;
		if (tmp_ymove < ydist)
			tmp_ymove = ydist;
	}
	else
	{
		tmp_ymove = tics * 32;
		if (tmp_ymove > ydist)
			tmp_ymove = ydist;
	}

	if (tmp_xmove == xdist && tmp_ymove == ydist)
	{
		ob->state = ob->state->nextstate;
		ob->needtoclip = FULLCLIP;
	}
}

void DopefishBurpThink(objtype *ob)
{
	GetNewObj(true);
	new->x = ob->x + 56*PIXGLOBAL;
	new->y = ob->y + 32*PIXGLOBAL;
	new->obclass = decoobj;
	new->priority = 3;
	new->active = removable;
	new->needtoclip = false;
	new->yspeed = -20;
	new->xspeed = 4;
	NewState(new, &s_bubble1);
	SD_PlaySound(SND_BURP);
}

void BubbleThink(objtype *ob)
{
	VelocityThink(ob);
	if (US_RndT() < tics * 16)
		ob->xspeed = -ob->xspeed;

	if (ob->y < 3*TILEGLOBAL)
		RemoveObj(ob);
}

void DopefishContact(objtype *ob, objtype *hit)
{
	if (hit->obclass == schoolfishobj)
	{
		ChangeState(hit, &s_schoolfishswallowed);
	}
	else if (hit->obclass == keenobj && !godmode)
	{
		hit->obclass = decoobj;	//prevents other objects from killing Keen before he is fully swallowed
		hit->needtoclip = false;
		SD_PlaySound(SND_KEENDEAD);
		ChangeState(hit, &s_scubakeenswallowed1);
	}
	else
	{
		return;
	}

	ob->temp2 = ob->x;
	ob->temp3 = ob->y;
	ob->temp4 = (Sint16)hit;
	if (hit->midx < ob->midx)
	{
		ob->xdir = -1;
	}
	else
	{
		ob->xdir = 1;
	}
	ChangeState(ob, &s_dopefishhungry);
	ob->needtoclip = false;
}

void FishReact(objtype *ob)	//for Dopefish and Schoolfish
{
	if ((ob->hitsouth || ob->hitnorth) && ob->temp1 == 0)
		ob->temp1++;

	if (ob->hiteast || ob->hitwest)
	{
		ob->xspeed = 0;
		ob->xdir = -ob->xdir;
		ob->temp1 = 1;
	}

	if (!ob->hitsouth && !ob->hitnorth)
		ob->temp1 = 0;

	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

/*
=============================================================================
	SCHOOLFISH

	temp1 - see dopefish
=============================================================================
*/

statetype s_schoolfish1   = {SCHOOLFISHL1SPR, SCHOOLFISHR1SPR, stepthink, false, push_none, 20, 0, 0, SchoolfishThink, NULL, FishReact, &s_schoolfish2};
statetype s_schoolfish2   = {SCHOOLFISHL2SPR, SCHOOLFISHR2SPR, stepthink, false, push_none, 20, 0, 0, SchoolfishThink, NULL, FishReact, &s_schoolfish1};

void SpawnSchoolfish(Sint16 x, Sint16 y)
{
	GetNewObj(false);
	new->obclass = schoolfishobj;
	new->active = yes;
	new->needtoclip = FULLCLIP;
	new->priority = 0;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = CONVERT_TILE_TO_GLOBAL(y);
	new->xdir = new->ydir = 1;
	NewState(new, &s_schoolfish1);
}

void SchoolfishThink(objtype *ob)
{
	if (ob->temp1 == 0)
	{
		if (ob->x < player->x)
		{
			ob->xdir = 1;
		}
		else
		{
			ob->xdir = -1;
		}
	}
	AccelerateX_0(ob, ob->xdir, 10);

	if (ob->y < player->y)
	{
		AccelerateY(ob, 1, 10);
	}
	else
	{
		AccelerateY(ob, -1, 10);
	}
}

/*
=============================================================================
	SPRITE

	temp1 - inital y psoition
=============================================================================
*/

statetype s_sprite        = {SPRITEFLOATSPR,  SPRITEFLOATSPR,  think, false, push_none, 10, 0, 0, SpriteThink, HazardContact, DrawReact, &s_sprite};
statetype s_spriteaim     = {SPRITEAIMLSPR,   SPRITEAIMRSPR,   step, false, push_none, 40, 0, 0, SpriteAimThink, HazardContact, DrawReact, &s_sprite};
statetype s_spriteattack1 = {SPRITESHOOTLSPR, SPRITESHOOTRSPR, step, false, push_none, 40, 0, 0, SpriteAttackThink, HazardContact, DrawReact, &s_spriteattack2};
statetype s_spriteattack2 = {SPRITESHOOTLSPR, SPRITESHOOTRSPR, step, false, push_none, 30, 0, 0, NULL, HazardContact, DrawReact, &s_sprite};
statetype s_spriteshot1   = {SPRITESHOT1SPR,  SPRITESHOT1SPR,  slide, false, push_none, 10, 64, 0, NULL, HazardContact, ProjectileReact, &s_spriteshot2};
statetype s_spriteshot2   = {SPRITESHOT2SPR,  SPRITESHOT2SPR,  slide, false, push_none, 10, 64, 0, NULL, HazardContact, ProjectileReact, &s_spriteshot3};
statetype s_spriteshot3   = {SPRITESHOT3SPR,  SPRITESHOT3SPR,  slide, false, push_none, 10, 64, 0, NULL, HazardContact, ProjectileReact, &s_spriteshot4};
statetype s_spriteshot4   = {SPRITESHOT4SPR,  SPRITESHOT4SPR,  slide, false, push_none, 10, 64, 0, NULL, HazardContact, ProjectileReact, &s_spriteshot1};

void SpawnSprite(Sint16 x, Sint16 y)
{
	GetNewObj(false);
	new->obclass = spriteobj;
	new->active = yes;
	new->priority = 0;
	new->needtoclip = false;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = new->temp1 = CONVERT_TILE_TO_GLOBAL(y);
	new->xdir = new->ydir = 1;
	NewState(new, &s_sprite);
}

void SpriteThink(objtype *ob)
{
	AccelerateY(ob, ob->ydir, 8);
	if ((Sint16)(ob->temp1 - ob->y) > 2*PIXGLOBAL)
	{
		ob->ydir = 1;
	}
	if ((Sint16)(ob->y - ob->temp1) > 2*PIXGLOBAL)
	{
		ob->ydir = -1;
	}

	if (player->top < ob->bottom && player->bottom > ob->top)
	{
		if (player->x < ob->x)
		{
			ob->xdir = -1;
		}
		else
		{
			ob->xdir = 1;
		}
		ob->state = &s_spriteaim;
	}
}

void SpriteAimThink(objtype *ob)
{
	if (player->top < ob->bottom && player->bottom > ob->top)
		ob->state = &s_spriteattack1;
}

void SpriteAttackThink(objtype *ob)
{
	GetNewObj(true);
	new->x = ob->x;
	new->y = ob->y + 8*PIXGLOBAL;
	new->priority = 3;
	SD_PlaySound(SND_KEENFIRE);	//BUG?
	new->xdir = ob->xdir;
	NewState(new, &s_spriteshot1);
	SD_PlaySound(SND_SPRITEFIRE);
}

void ProjectileReact(objtype *ob)
{
	if (ob->hitnorth || ob->hiteast || ob->hitsouth || ob->hitwest)
	{
		RemoveObj(ob);
	}
	else
	{
		RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
	}
}

/*
=============================================================================
	MINE
=============================================================================
*/

statetype s_mine          = {MINESPR,         MINESPR,         think, false, push_none, 10, 0, 0, PlatformThink, MineContact, DrawReact, &s_mine};
statetype s_mineexplode1  = {MINEEXPLODE1SPR, MINEEXPLODE1SPR, step, false, push_none, 30, 0, 0, NULL, NULL, DrawReact, &s_mineexplode2};
statetype s_mineexplode2  = {MINEEXPLODE2SPR, MINEEXPLODE2SPR, step, false, push_none, 30, 0, 0, NULL, NULL, DrawReact, NULL};

void SpawnMine(Sint16 x, Sint16 y, Sint16 dir)
{
	GetNewObj(false);
	new->obclass = mineobj;
	new->active = allways;
	new->priority = 0;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = CONVERT_TILE_TO_GLOBAL(y);
	switch (dir)
	{
	case 0:
		new->xdir = 0;
		new->ydir = -1;
		break;
	case 1:
		new->xdir = 1;
		new->ydir = 0;
		break;
	case 2:
		new->xdir = 0;
		new->ydir = 1;
		break;
	case 3:
		new->xdir = -1;
		new->ydir = 0;
		break;
	}
	NewState(new, &s_mine);
}

void MineContact(objtype *ob, objtype *hit)
{
	if (hit->obclass == keenobj)
	{
		ChangeState(ob, &s_mineexplode1);
		SD_PlaySound(SND_MINEEXPLODE);
		KillKeen();
	}
}

/*
=============================================================================
	PRINCESS LINDSEY

	temp1 - initial y position
=============================================================================
*/

statetype s_lindsey1      = {LINDSEY1SPR, LINDSEY1SPR, stepthink, false, push_none, 20, 0, 0, LindseyThink, NULL, DrawReact, &s_lindsey2};
statetype s_lindsey2      = {LINDSEY2SPR, LINDSEY2SPR, stepthink, false, push_none, 20, 0, 0, LindseyThink, NULL, DrawReact, &s_lindsey3};
statetype s_lindsey3      = {LINDSEY3SPR, LINDSEY3SPR, stepthink, false, push_none, 20, 0, 0, LindseyThink, NULL, DrawReact, &s_lindsey4};
statetype s_lindsey4      = {LINDSEY4SPR, LINDSEY4SPR, stepthink, false, push_none, 20, 0, 0, LindseyThink, NULL, DrawReact, &s_lindsey1};

void SpawnLindsey(Sint16 x, Sint16 y)
{
	GetNewObj(false);
	new->obclass = lindseyobj;
	new->active = yes;
	new->priority = 0;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = new->temp1 = CONVERT_TILE_TO_GLOBAL(y) - TILEGLOBAL;
	new->ydir = 1;
	NewState(new, &s_lindsey1);
}

void LindseyThink(objtype *ob)
{
	AccelerateY(ob, ob->ydir, 8);
	if (ob->temp1 - (Sint16)ob->y > 2*PIXGLOBAL)
	{
		ob->ydir = 1;
	}
	if ((Sint16)ob->y - ob->temp1 > 2*PIXGLOBAL)
	{
		ob->ydir = -1;
	}
}

/*
=============================================================================
	DART SHOOTER

	temp1 - direction
=============================================================================
*/

statetype s_dartshooter   = {0, 0, step, false, push_none, 150, 0, 0, DartshooterThink, NULL, NULL, &s_dartshooter};
statetype s_dart1         = {DART1LSPR, DART1RSPR, slide, false, push_none, 6, 64, 0, NULL, HazardContact, ProjectileReact, &s_dart2};
statetype s_dart2         = {DART2LSPR, DART2RSPR, slide, false, push_none, 6, 64, 0, NULL, HazardContact, ProjectileReact, &s_dart1};
statetype s_dartup1       = {DART1USPR, DART1USPR, slide, false, push_none, 6, 0, 64, NULL, HazardContact, ProjectileReact, &s_dartup2};
statetype s_dartup2       = {DART2USPR, DART2USPR, slide, false, push_none, 6, 0, 64, NULL, HazardContact, ProjectileReact, &s_dartup1};
statetype s_dartdown1     = {DART1DSPR, DART1DSPR, slide, false, push_none, 6, 0, 64, NULL, HazardContact, ProjectileReact, &s_dartdown2};
statetype s_dartdown2     = {DART2DSPR, DART2DSPR, slide, false, push_none, 6, 0, 64, NULL, HazardContact, ProjectileReact, &s_dartdown1};

void SpawnDartShooter(Sint16 x, Sint16 y, Sint16 dir)
{
	GetNewObj(false);
	new->obclass = decoobj;
	new->active = yes;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->needtoclip = false;
	new->y = CONVERT_TILE_TO_GLOBAL(y);
	new->temp1 = dir;
	switch (dir)
	{
	case 0:
		new->y -= 3*PIXGLOBAL;
		new->x += 9*PIXGLOBAL;
		new->shapenum = DART1USPR;
		break;
	case 1:
		new->x += 8*PIXGLOBAL;
		new->y += 5*PIXGLOBAL;
		new->shapenum = DART1RSPR;
		break;
	case 2:
		new->x += 9*PIXGLOBAL;
		new->shapenum = DART1DSPR;
		break;
	case 3:
		new->y += 7*PIXGLOBAL;
		new->x -= 3*PIXGLOBAL;
		new->shapenum = DART1LSPR;
		break;
	}
	NewState(new, &s_dartshooter);
}

void DartshooterThink(objtype *ob)
{
	GetNewObj(true);
	new->x = ob->x;
	new->y = ob->y;
	new->obclass = spriteshotobj;
	new->active = removable;
	switch (ob->temp1)
	{
	case 0:
		new->xdir = 0;
		new->ydir = -1;
		NewState(new, &s_dartup1);
		break;
	case 1:
		new->xdir = 1;
		new->ydir = 0;
		NewState(new, &s_dart1);
		break;
	case 2:
		new->xdir = 0;
		new->ydir = 1;
		NewState(new, &s_dartdown1);
		break;
	case 3:
		new->xdir = -1;
		new->ydir = 0;
		NewState(new, &s_dart1);
		break;
	}
	SD_PlaySound(SND_SHOOTDART);
}

void DartReact(objtype *ob)	//never used
{
	RF_PlaceSprite(&ob->sprite, ob->x, ob->y, ob->shapenum, 0, ob->priority);
}

/*
=============================================================================
	WETSUIT
=============================================================================
*/

statetype s_wetsuit       = {WETSUITSPR, WETSUITSPR, step, false, push_none, 30000, 0, 0, NULL, WetsuitContact, DrawReact, &s_wetsuit};

void SpawnWetsuit(Sint16 x, Sint16 y)
{
	GetNewObj(false);
	new->obclass = wetsuitobj;
	new->active = yes;
	new->x = CONVERT_TILE_TO_GLOBAL(x);
	new->y = CONVERT_TILE_TO_GLOBAL(y) + -TILEGLOBAL;
	NewState(new, &s_wetsuit);
}

void WetsuitContact(objtype *ob, objtype *hit)
{
	if (hit->obclass == keenobj && hit->state->contact)	// RTTS mod: Keen's state must have a contact function (Keen must be still alive)
	{
		gamestate.wetsuit= true;
		SD_PlaySound(SND_MAKEFOOT);
		WetsuitMessage();
		RF_ForceRefresh();
		playstate = ex_completed;
		ob++;
	}
}