/* Return To The Shadowlands Source Code
 * (Based On Reconstructed Commander Keen 4-6 Source Code)
 * Copyright (C) 2021 K1n9_Duk3
 *
 * The code in this file is loosely based on
 * Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __K4_DEF__
#define __K4_DEF__

/*
=============================================================================

						GLOBAL CONSTANTS

=============================================================================
*/

#define MINMEMORY 432000l	// RTTS mod: minimum requirement has changed

#define CRAWLPALETTE {0, 1, 2, 3, 4, 16, 6, 7, 31, 31, 31, 31, 31, 31, 31, 31, 0}
#define INTROPALETTE	{0, 4, 4, 28, 1, 1, 1, 1, 17, 17, 17, 17, 19, 19, 19, 19, 0}	// RTTS mod: red "COMMANDER KEEN" text
#define SHRINKPALETTE	{0, 4, 4, 28, 4, 1, 1, 1, 17, 17, 17, 17, 19, 19, 19, 4, 0}	// RTTS mod: red "COMMANDER KEEN" text

#define HIGHSCORE_LEFT	24
#define HIGHSCORE_TOP	51
#define HIGHSCORE_RIGHT	296
#define HIGHSCORE_MAP	19

#define STATUS_PRESSKEY_X 160

#define WORLDMAPNAME "Shadowlands"
#define LIFECRUMBNAME "DROPS"

#define TEXTCRAWLMUSIC	14
#define ENDINGMUSIC	5

// levels in this range can NOT be re-entered (BWB level should be > MAXDONELEVEL)
#define MINDONELEVEL 1
#define MAXDONELEVEL 18

#define INACTIVATEDIST 4

/*
=============================================================================

						K4_LEVEL DEFINITIONS

=============================================================================
*/

extern char far crawltext[];
extern char far *levelnames[GAMELEVELS];
extern char far *levelmessages[GAMELEVELS];

void ScanInfoPlane(void);
void LindseyDialog(void);
void JanitorDialog(void);
void CantSwimMessage(void);
void WetsuitMessage(void);
void OracleDialog(void);

extern statetype s_scubakeen1;
extern statetype s_scubakeen2;
extern statetype s_scubakeenfast1;
extern statetype s_scubakeenfast2;
extern statetype s_smallbubble1;
extern statetype s_smallbubble2;
extern statetype s_smallbubble3;
extern statetype s_smallbubble4;
void SpawnScubaKeen(Sint16 x, Sint16 y);
void SpawnBubble(objtype *ob);
void KeenScubaThink(objtype *ob);
void KeenScubaFastThink(objtype *ob);
void KeenScubaContact(objtype *ob, objtype *hit);
void KeenScubaReact(objtype *ob);

/*
=============================================================================

						K4_ACT1 DEFINITIONS

=============================================================================
*/

extern statetype s_miragia1;
extern statetype s_miragia2;
extern statetype s_miragia3;
extern statetype s_miragia4;
extern statetype s_miragia5;
extern statetype s_miragia6;
extern statetype s_miragia7;
extern statetype s_miragia8;
void SpawnMiragia(Sint16 x, Sint16 y);
void MiragiaThink1(objtype *ob);
void MiragiaThink2(objtype *ob);
void MiragiaThink3(objtype *ob);
void MiragiaThink4(objtype *ob);
void MiragiaThink5(objtype *ob);
void MiragiaThink6(objtype *ob);
void MiragiaThink7(objtype *ob);
void MiragiaThink8(objtype *ob);

extern statetype s_bonus1;
extern statetype s_bonus2;
extern statetype s_bonusrise;
extern statetype s_splash1;
extern statetype s_splash2;
extern statetype s_splash3;
extern Uint16 bonusshape[];
void SpawnBonus(Sint16 x, Sint16 y, Sint16 type);
void SpawnSplash(Sint16 x, Sint16 y);
void BonusThink(objtype *ob);

extern statetype s_oraclewalk1;
extern statetype s_oraclewalk2;
extern statetype s_oraclestand;
void SpawnOracle(Sint16 x, Sint16 y);
void OracleWalkThink(objtype *ob);

extern statetype s_slugwalk1;
extern statetype s_slugwalk2;
extern statetype s_slugpoo;
extern statetype s_slugstunned1;
extern statetype s_slugstunned2;
extern statetype s_slugstain1;
extern statetype s_slugstain2;
void SpawnSlug(Sint16 x, Sint16 y);
void SlugWalkThink(objtype *ob);
void SlugPooThink(objtype *ob);
void SlugContact(objtype *ob, objtype *hit);

extern statetype s_madmushroom1;
extern statetype s_madmushroom2;
void SpawnMadMushroom(Sint16 x, Sint16 y);
void MadMushroomThink(objtype *ob);
void MadMushroomContact(objtype *ob, objtype *hit);
void MadMushroomReact(objtype *ob);

extern statetype s_egg;
extern statetype s_brokenegg;
extern statetype s_eggpiece1;
extern statetype s_eggpiece2;
extern statetype s_eggpiece3;
extern statetype s_eaglespawn;
extern statetype s_eaglewalk1;
extern statetype s_eaglewalk2;
extern statetype s_eaglewalk3;
extern statetype s_eaglewalk4;
extern statetype s_eaglefly1;
extern statetype s_eaglefly2;
extern statetype s_eaglefly3;
extern statetype s_eaglefly4;
extern statetype s_eagleUNUSED;
extern statetype s_eaglestunned1;
extern statetype s_eaglestunned2;
extern statetype s_eaglestunned3;
extern statetype s_eaglestunned4;
extern statetype s_eaglestunned5;
void SpawnEgg(Sint16 x, Sint16 y);
void EagleStunnedThink(objtype *ob);
void SpawnEagle(Sint16 x, Sint16 y);
void EggContact(objtype *ob, objtype *hit);
void EagleWalkThink(objtype *ob);
void EagleFlyThink(objtype *ob);
void EagleContact(objtype *ob, objtype *hit);
void EagleHarmlessContact(objtype *ob, objtype *hit);
void EagleWalkReact(objtype *ob);
void EagleUnusedReact(objtype *ob);
void EggPieceReact(objtype *ob);
void EagleFlyReact(objtype *ob);

extern statetype s_arachnutwalk1;
extern statetype s_arachnutwalk2;
extern statetype s_arachnutwalk3;
extern statetype s_arachnutwalk4;
extern statetype s_arachnutstunned1;
extern statetype s_arachnutstunned2;
extern statetype s_arachnutstunned3;
extern statetype s_arachnutstunned4;
extern statetype s_arachnutstunned5;
void SpawnArachnut(Sint16 x, Sint16 y);
void ArachnutThink(objtype *ob);
void ArachnutContact(objtype *ob, objtype *hit);
void ArachnutStunnedContact(objtype *ob, objtype *hit);

extern statetype s_skypestfly1;
extern statetype s_skypestfly2;
extern statetype s_skypestsquished;
extern statetype s_skypeststand1;
extern statetype s_skypeststand2;
extern statetype s_skypeststand3;
extern statetype s_skypeststand4;
extern statetype s_skypeststand5;
extern statetype s_skypeststand6;
extern statetype s_skypeststand7;
extern statetype s_skypeststand8;
extern statetype s_skypeststand9;
extern statetype s_skypeststand10;
extern statetype s_skypeststand11;
extern statetype s_skypeststand12;
extern statetype s_skypeststand13;
extern statetype s_skypeststand14;
extern statetype s_skypeststand15;
extern statetype s_skypeststand16;
extern statetype s_skypeststand17;
void SpawnSkypest(Sint16 x, Sint16 y);
void SkypestFlyThink(objtype *ob);
void SkypestFlyContact(objtype *ob, objtype *hit);
void SkypestStandContact(objtype *ob, objtype *hit);
void SkypestStandThink(objtype *ob);
void SkypestFlyReact(objtype *ob);

/*
=============================================================================

						K4_ACT2 DEFINITIONS

=============================================================================
*/

extern statetype s_wormouth;
extern statetype s_wormouthlook1;
extern statetype s_wormouthlook2;
extern statetype s_wormouthlook3;
extern statetype s_wormouthlook4;
extern statetype s_wormouthlook5;
extern statetype s_wormouthlook6;
extern statetype s_wormouthlook7;
extern statetype s_wormouthlook8;
extern statetype s_wormouthattack1;
extern statetype s_wormouthattack2;
extern statetype s_wormouthattack3;
extern statetype s_wormouthattack4;
extern statetype s_wormouthattack5;
extern statetype s_wormouthstunned;
void SpawnWormouth(Sint16 x, Sint16 y);
void WormouthLookRightThink(objtype *ob);
void WormouthLookThink(objtype *ob);
void WormouthLookLeftThink(objtype *ob);
void WormouthThink(objtype *ob);
void WormouthLookContact(objtype *ob, objtype *hit);
void WormouthAttackContact(objtype *ob, objtype *hit);

extern statetype s_thundercloud;
extern statetype s_thundercloudactive1;
extern statetype s_thundercloudactive2;
extern statetype s_thundercloudfloat1;
extern statetype s_thundercloudattack10;
extern statetype s_thundercloudattack1;
extern statetype s_thundercloudattack2;
extern statetype s_thundercloudattack3;
extern statetype s_thundercloudattack4;
extern statetype s_thundercloudattack5;
extern statetype s_thundercloudattack6;
extern statetype s_thundercloudattack7;
extern statetype s_thundercloudattack8;
extern statetype s_thundercloudattack9;
extern statetype s_lightning1;
extern statetype s_lightning2;
extern statetype s_lightning3;
extern statetype s_lightning4;
extern statetype s_lightning5;
extern statetype s_lightning6;
void SpawnThundercloud(Sint16 x, Sint16 y);
void ThundercloudThink(objtype *ob);
void ThundercloudFloatThink(objtype *ob);
void ThundercloudReact(objtype *ob);
void ThundercloudAttackThink(objtype *ob);
void ThundercloudContact(objtype *ob, objtype *hit);

extern statetype s_berkeloidwalk1;
extern statetype s_berkeloidwalk2;
extern statetype s_berkeloidwalk3;
extern statetype s_berkeloidwalk4;
extern statetype s_berkeloidattack1;
extern statetype s_berkeloidattack2;
extern statetype s_berkeloidattack3;
extern statetype s_berkeloidattack4;
extern statetype s_berkeloidattack5;
extern statetype s_berkeloidattack6;
extern statetype s_berkeloidattack7;
extern statetype s_berkeloidattack8;
extern statetype s_berkeloidattack9;
extern statetype s_berkeloidattack10;
extern statetype s_berkeloidattack11;
extern statetype s_berkeloidattack12;
extern statetype s_fireball1;
extern statetype s_fireball2;
extern statetype s_fireball3;
extern statetype s_fireball4;
extern statetype s_fireball5;
extern statetype s_fireball6;
extern statetype s_fireball7;
extern statetype s_fireball8;
extern statetype s_fireball9;
extern statetype s_fireball10;
extern statetype s_fireball11;
void SpawnBerkeloid(Sint16 x, Sint16 y);
void BerkeloidWalkThink(objtype *ob);
void BerkeloidAttackThink(objtype *ob);
void BerkeloidAfterAttackThink(objtype *ob);
void BerkeloidContact(objtype *ob, objtype *hit);
void FireballReact(objtype *ob);
void BerkeloidReact(objtype *ob);
void BerkeloidWalkReact(objtype *ob);

extern statetype s_smoke1;
extern statetype s_smoke2;
extern statetype s_smoke3;
extern statetype s_smoke4;
extern statetype s_inchworm1;
extern statetype s_inchworm2;
extern statetype s_footappear;	//never used!
extern statetype s_afoot;
void SpawnInchworm(Sint16 x, Sint16 y);
void SpawnFoot(Sint16 x, Sint16 y);
void InchwormThink(objtype *ob);
void InchwormContact(objtype *ob, objtype *hit);
void FootContact(objtype *ob, objtype *hit);

extern statetype s_bounderc1;
extern statetype s_bounderc2;
extern statetype s_bounder1;
extern statetype s_bounder2;
extern statetype s_bounderstunned0;
extern statetype s_bounderstunned1;
void SpawnBounder(Sint16 x, Sint16 y);
void BounderContact(objtype *ob, objtype *hit);
void BounderReact(objtype *ob);

extern statetype s_lick1;
extern statetype s_lick2;
extern statetype s_lick3;
extern statetype s_lickground;
extern statetype s_lickattack1;
extern statetype s_lickattack2;
extern statetype s_lickattack3;
extern statetype s_lickattack4;
extern statetype s_lickattack5;
extern statetype s_lickattack6;
extern statetype s_lickattack7;
extern statetype s_lickattack8;
extern statetype s_lickstunned1;
extern statetype s_lickstunned2;
void SpawnLick(Sint16 x, Sint16 y);
void LickThink(objtype *ob);
void LickContact(objtype *ob, objtype *hit);
void LickAttackContact(objtype *ob, objtype *hit);
void LickReact(objtype *ob);

extern statetype s_platform;
void SpawnPlatform(Sint16 x, Sint16 y, Sint16 dir);
void PlatformThink(objtype *ob);
void PlatformReact(objtype *ob);

extern statetype s_looseplatform;
extern statetype s_platformsink;
extern statetype s_platformrise;
void SpawnLoosePlatform(Sint16 x, Sint16 y);
void LoosePlatformThink(objtype *ob);
void PlatformSinkThink(objtype *ob);
void PlatformRiseThink(objtype *ob);

/*
=============================================================================

						K4_ACT3 DEFINITIONS

=============================================================================
*/

extern statetype s_treasureeater1;
extern statetype s_treasureeater2;
extern statetype s_treasureeatervanish1;
extern statetype s_treasureeatervanish2;
extern statetype s_treasureeatervanish3;
extern statetype s_treasureeatervanish4;
extern statetype s_treasureeatervanish5;
extern statetype s_treasureeatervanish6;
extern statetype s_treasureeatervanish7;
extern statetype s_treasureeatervanish8;
extern statetype s_treasureeaterjump1;
extern statetype s_treasureeaterjump2;
extern statetype s_treasureeaterjump3;
extern statetype s_treasureeaterjump4;
extern statetype s_treasureeaterstunned1;
extern statetype s_treasureeaterstunned2;
extern statetype s_killedbonus1;
extern statetype s_killedbonus2;
extern statetype s_killedbonus3;
extern statetype s_killedbonus4;
void SpawnTreasureeater(Sint16 x, Sint16 y);
void TreasureeaterThink(objtype *ob);
void TreasureeaterVanishThink(objtype *ob);
void TreasureeaterContact(objtype *ob, objtype *hit);
void TreasureeaterCheckTiles(objtype *ob);
void TreasureeaterJumpReact(objtype *ob);

extern statetype s_mimrock;
extern statetype s_mimrockwalk1;
extern statetype s_mimrockwalk2;
extern statetype s_mimrockwalk3;
extern statetype s_mimrockwalk4;
extern statetype s_mimrockwalk5;
extern statetype s_mimrockwalk6;
extern statetype s_mimrockjump1;
extern statetype s_mimrockjump2;
extern statetype s_mimrockjump3;
extern statetype s_mimrockbounce;
extern statetype s_mimrockstunned1;
extern statetype s_mimrockstunned2;
void SpawnMimrock(Sint16 x, Sint16 y);
void MimrockThink(objtype *ob);
void MimrockWalkThink(objtype *ob);
void MimrockWalkContact(objtype *ob, objtype *hit);
void MimrockJumpContact(objtype *ob, objtype *hit);
void MimrockJumpReact(objtype *ob);
void MimrockBounceReact(objtype *ob);

extern statetype s_dopefishswim1;
extern statetype s_dopefishswim2;
extern statetype s_dopefishhungry;
extern statetype s_dopefishpreburp;
extern statetype s_dopefishburp1;
extern statetype s_dopefishburp2;
extern statetype s_dopefishafterburp;
extern statetype s_schoolfishswallowed;
extern statetype s_scubakeenswallowed1;
extern statetype s_scubakeenswallowed2;
extern statetype s_bubble1;
extern statetype s_bubble2;
extern statetype s_bubble3;
extern statetype s_bubble4;
void SpawnDopefish(Sint16 x, Sint16 y);
void ScubaKeenSwallowedThink(objtype *ob);
void DopefishSwimThink(objtype *ob);
void DopefishHungryThink(objtype *ob);
void DopefishAfterBurpThink(objtype *ob);
void DopefishBurpThink(objtype *ob);
void BubbleThink(objtype *ob);
void DopefishContact(objtype *ob, objtype *hit);
void FishReact(objtype *ob);

extern statetype s_schoolfish1;
extern statetype s_schoolfish2;
void SpawnSchoolfish(Sint16 x, Sint16 y);
void SchoolfishThink(objtype *ob);

extern statetype s_sprite;
extern statetype s_spriteaim;
extern statetype s_spriteattack1;
extern statetype s_spriteattack2;
extern statetype s_spriteshot1;
extern statetype s_spriteshot2;
extern statetype s_spriteshot3;
extern statetype s_spriteshot4;
void SpawnSprite(Sint16 x, Sint16 y);
void SpriteThink(objtype *ob);
void SpriteAimThink(objtype *ob);
void SpriteAttackThink(objtype *ob);
void ProjectileReact(objtype *ob);

extern statetype s_mine;
extern statetype s_mineexplode1;
extern statetype s_mineexplode2;
void SpawnMine(Sint16 x, Sint16 y, Sint16 dir);
void MineContact(objtype *ob, objtype *hit);

extern statetype s_lindsey1;
extern statetype s_lindsey2;
extern statetype s_lindsey3;
extern statetype s_lindsey4;
void SpawnLindsey(Sint16 x, Sint16 y);
void LindseyThink(objtype *ob);

extern statetype s_dartshooter;
extern statetype s_dart1;
extern statetype s_dart2;
extern statetype s_dartup1;
extern statetype s_dartup2;
extern statetype s_dartdown1;
extern statetype s_dartdown2;
void SpawnDartShooter(Sint16 x, Sint16 y, Sint16 dir);
void DartshooterThink(objtype *ob);
void DartReact(objtype *ob);

extern statetype s_wetsuit;
void SpawnWetsuit(Sint16 x, Sint16 y);
void WetsuitContact(objtype *ob, objtype *hit);


/*
=============================================================================

						K4_ACT4 DEFINITIONS

=============================================================================
*/

void SpawnBadoing(Sint16 x, Sint16 y);
void SpawnWitchDoctor(Sint16 x, Sint16 y);
void SpawnJanitor(Sint16 x, Sint16 y);
void SpawnStingaru(Sint16 x, Sint16 y);

#endif